package cnv.hf.widgets;

import android.view.animation.AlphaAnimation;
import android.view.animation.Animation;
import android.view.animation.Animation.AnimationListener;
import android.view.animation.Interpolator;
import android.view.animation.RotateAnimation;
import android.view.animation.ScaleAnimation;
import android.view.animation.TranslateAnimation;

public class HFAnimationFactory {
	public static TranslateAnimation getTranslateAnimation(float fromXValue, float toXValue, float fromYValue, float toYValue,long durationMillis,Interpolator interpolator,AnimationListener listener){
	  TranslateAnimation mAction = new TranslateAnimation(Animation.ABSOLUTE,   
			fromXValue, Animation.ABSOLUTE, toXValue,   
            Animation.ABSOLUTE, fromYValue, Animation.ABSOLUTE,   
            toYValue);  
	  mAction.setDuration(durationMillis);  
	  if(interpolator != null)
		  mAction.setInterpolator(interpolator);
	  if(listener != null)
		    mAction.setAnimationListener(listener);
      return mAction;
	}
	
	public static ScaleAnimation getScaleAnimation(float fromX, float toX, float fromY, float toY, float pivotX, float pivotY,long durationMillis,Interpolator interpolator,AnimationListener listener){
		 ScaleAnimation mAction = new ScaleAnimation(fromX, toX, fromY, toY, pivotX, pivotY);
		 mAction.setDuration(durationMillis); 
		 if(interpolator != null)
			 mAction.setInterpolator(interpolator);
		 if(listener != null)
			    mAction.setAnimationListener(listener);
		  return mAction;
	}
	
	public static AlphaAnimation getAlphaAnimation(float fromAlpha, float toAlpha,long durationMillis,Interpolator interpolator,AnimationListener listener){
		AlphaAnimation mAction = new AlphaAnimation(fromAlpha, toAlpha); 
		mAction.setDuration(durationMillis);
		if(interpolator != null)
			mAction.setInterpolator(interpolator);
		if(listener != null)
		    mAction.setAnimationListener(listener);
		return mAction;
	}
	
	public static RotateAnimation getRotateAnimation(float fromDegrees, float toDegrees, float pivotXValue, float pivotYValue,long durationMillis,Interpolator interpolator,AnimationListener listener){
		RotateAnimation mAction = new RotateAnimation(fromDegrees, toDegrees,Animation.ABSOLUTE,pivotXValue,Animation.ABSOLUTE,pivotYValue); 
		mAction.setDuration(durationMillis);
		if(interpolator != null)
			mAction.setInterpolator(interpolator);
		if(listener != null)
		    mAction.setAnimationListener(listener);
		return mAction;
	}
	
    
}
