package cnv.hf.widgets;

import android.content.Context;
import android.graphics.drawable.AnimationDrawable;
import android.graphics.drawable.Drawable;
import android.widget.ImageView;
import cnv.hf.widgets.HFWidgetStorage.HFAnimationStorage;
import cnv.hf.widgets.HFWidgetStorage.HFImageFrameStorage;

public class HFAnimationWidget extends HFBaseWidget{

	private AnimationDrawable mAnimDrawable = null;
	 
	public HFAnimationWidget(Context context, Object widgetData) {
		super(context, widgetData);
		// TODO Auto-generated constructor stub
		mAnimDrawable = new AnimationDrawable();
		ImageView imageView = (ImageView)getObject();
		if(imageView != null) {
			imageView.setImageDrawable(mAnimDrawable);
		}
		initMembers(widgetData);
	}
	@Override
	protected void setHolder(Context context,Object widgetData) {
		setObject(new ImageView(context));
	}
	//@Override
	protected void initMembers(Object widgetData) {
		//super.initMembers(widgetData);
		HFAnimationStorage data = (HFAnimationStorage)widgetData;
		if(data != null) {
			int index;
			HFImageFrame frame = new HFImageFrame();
			HFImageFrameStorage frameStorage = null;
			for(index = 0; index < data.getNumOfFrames(); index++) {
				frameStorage = data.getFrame(index);
				frame.setFrame(getDrawable(frameStorage.getDrawable()));
				frame.setDuration(frameStorage.getDuration());
				addFrame(frame);
			}
			setOneShot(((data.getOneshot() == 0) ? false : true));
		}
		return ;
	}
	/*======================================================
	: ȡAnimationؼĶ֡
	: 
	      in_ulIndex   [in]  ֡
	ֵ: ==0 ɹ >0 
	======================================================*/
	public HFImageFrame getFrame(int index) {
		HFImageFrame frame = null;
		if(index >= 0 && index < getNumOfFrames()) {
			frame = new HFImageFrame();
			frame.setFrame(mAnimDrawable.getFrame(index));
			frame.setDuration(mAnimDrawable.getDuration(index));
		}
		return frame;
	}
	/*=======================================================
	: AnimationؼĶ֡(ͼƬIdʱ)
	:  
	       in_pFrame        [in] ֡
	ֵ: ==0 ɹ >0 
	======================================================*/
	public void addFrame(HFImageFrame frame) {
		if(frame != null && frame.getFrame()!= null) {
			mAnimDrawable.addFrame(frame.getFrame(), frame.getDuration());
		}
	}
	/*======================================================
	: ȡAnimationؼĶ֡ĸ
	: 
	ֵ: ֡ĸ
	======================================================*/
	public int getNumOfFrames() {
		return mAnimDrawable.getNumberOfFrames();
	}
	/*======================================================
	: ȡAnimationؼĲ
	: widget ؼָ
	ֵ: 
	======================================================*/
	public boolean getOneShot() {
		return mAnimDrawable.isOneShot();
	}
	/*======================================================
	: AnimationؼĲ
	:  widget            [in] ؼָ
	       in_ucOneShot      [in] 
	ֵ: ==0 ɹ >0 
	======================================================*/
	public void setOneShot(boolean oneShot) {
		mAnimDrawable.setOneShot(oneShot);
	}	
	/*======================================================
	: ʵAnimationؼĿʼź
	:  
	ֵ: 
	======================================================*/
	public void start() {
		mAnimDrawable.start();
	}
	/*======================================================
	: ʵAnimationؼֹͣź
	:  
	ֵ: 
	======================================================*/
	public void stop() {
		mAnimDrawable.stop();
	}	
	public static class HFImageFrame {
		private Drawable frame;
		private int duration;
		public HFImageFrame() {
		}
		public HFImageFrame(Drawable frame, int duration) {
			this.frame = frame;
			this.duration = duration;
		}
		public Drawable getFrame() {
			return frame;
		}
		public void setFrame(Drawable frame) {
			this.frame = frame;
		}
		public int getDuration() {
			return duration;
		}
		public void setDuration(int duration) {
			this.duration = duration;
		}
	}

}
