package cnv.hf.widgets;

import java.util.ArrayList;

import android.content.Context;
import android.view.View;
import cnv.hf.widgets.HFWidgetStorage.HFExtendAttrStorage;
import cnv.hf.widgets.HFWidgetStorage.HFObjectStorage;

public class HFBaseObject {
	private View			mObject = null;
	private int				widgetId;						/*ؼID*/			
	private String			widgetName;						/*ؼ*/			
	private HFWidgetBound	widgetBound;					/*ؼλúʹС*/	
	private short			widgetType;						/*ؼ*/
	private short			widgetSubType;					/*ؼ*/
	private byte            b7ExtendAttr;                   /*Ը*/  
	private byte            b2VeiledEffect;                 /*ɴЧ*/
	private Object 			mLayout = null;			
	private	ArrayList<HFExtendAttr>  ExtendAttrs;
	
	/*======================================================
	: Ĺ캯
	: Context 		[in] Context
	      widgetData 	[in] 	
	ֵ: 
	======================================================*/
	public HFBaseObject(Context context, Object widgetData) {
		mLayout = null;
		widgetName = "";
		widgetBound = new HFWidgetBound(0, 0, 0, 0);
		setHolder(context,widgetData);
		initObjectMembers(widgetData);
	}
	/*======================================================
	: ÿؼĳԱ
	: Context [in] Context
	      widgetData:
	ֵ: 
	======================================================*/	
	protected void setHolder(Context context,Object widgetData) {
		return ;
	}
	/*======================================================
	: ʼؼĳԱ
	: widgetData [in] ؼ
	ֵ: ؼ
	======================================================*/
	private void initObjectMembers(Object widgetData) {
	
		HFObjectStorage data = (HFObjectStorage)widgetData;
		if(data != null) {
			setBound(data.getBound());
			setName(data.getName());
			setId(data.getId());
			setType(data.getType());
			setVeiledEffect(data.getB2VeiledEffect());
			b7ExtendAttr = data.getNumOfExtendAttr();
			setExtendAttr(data.getExtendAttrs());
		}
	}

	/*======================================================
	: ȡؼĳԱ
	: 
	ֵ: Ա
	======================================================*/	
	public View getObject() {
		return mObject;
	}
	/*======================================================
	: ÿؼĳԱ
	: object [in] Ա
	ֵ: 
	======================================================*/	
	protected void setObject(View object) {
		this.mObject = object;
	}
	/*=======================================================
	: ȡؼId
	: 
	ֵ: ؼId
	======================================================*/	
	public int getId() {
		return widgetId;
	}
	/*=======================================================
	: ÿؼId
	: id [in] ؼId
	ֵ: 
	======================================================*/
	public void setId(int id) {
		widgetId = id;
	}
	/*=======================================================
	: ȡؼ
	: widget ؼָ
	ֵ: ؼ
	======================================================*/
	public String getName() {
		return widgetName;
	}
	/*=======================================================
	: ÿؼ
	: name [in] ؼ
	ֵ: 
	======================================================*/	
	protected void setName(String name) {
		widgetName = name;
	}
	/*=======================================================
	: ȡؼλ
	: 
	ֵ:  ؼλ
	======================================================*/	
	public HFWidgetBound getBound() {
		return widgetBound;
	}
	public void getBound(HFWidgetBound bound) {
		if(bound != null) {
			bound.setBound(widgetBound);
		}
		return ;
	}
	/*=======================================================
	: ø
	: 
	ֵ:  
	======================================================*/
	private void setExtendAttr(ArrayList<HFExtendAttrStorage> extendAttrs){
		if(extendAttrs != null){
			ExtendAttrs = new ArrayList<HFExtendAttr>();
			for(int i = 0; i < extendAttrs.size(); i++){
				HFExtendAttr attr = new HFExtendAttr();
				attr.setType(extendAttrs.get(i).getType());
				attr.setValue(extendAttrs.get(i).getValue());
				ExtendAttrs.add(attr);
			}
		}
	}
	/*=======================================================
	: ȡؼλ
	: 
	ֵ:  ؼλ
	======================================================*/	
	public void getBoundOnScreen(HFWidgetBound bound) {
		getBound(bound);
		View view = this.getObject();
		if(view != null) {
			int[] location = new int[2];
			view.getLocationOnScreen(location);
			bound.setLeft(location[0]);
			bound.setTop(location[1]);
		}
	}
	/*=======================================================
	: ÿؼλ
	:  in_pBound  [in] ؼλ
	ֵ: 
	======================================================*/
	public void setBound(HFWidgetBound bound) {
		if(bound != null) {
			widgetBound.setBound(bound);
			HFLayerWidget layer = (HFLayerWidget)mLayout;
			if(layer != null) {
				layer.relayout(this);
			}
		}
	}
	/*======================================================
	: ȡؼ
	: widget ؼָ
	ֵ: ؼ
	======================================================*/	
	public short getType() {
		return widgetType;
	}
	/*=======================================================
	: ÿؼ
	:  in_eType   [in] ؼ
	
	ֵ: 
	======================================================*/
	protected void setType(short type) {
		widgetType = type;
	}
	/*======================================================
	: ȡؼ
	: 
	ֵ: ؼ
	======================================================*/	
	public short getSubType() {
		return widgetSubType;
	}
	/*=======================================================
	: ÿؼ
	:  in_eType   [in] ؼ
	ֵ: 
	======================================================*/
	protected void setSubType(short type) {
		this.widgetSubType = type;
	}
	/*=======================================================
	: ÿؼlayout
	:  layout [in] ؼlayout
	ֵ: 
	======================================================*/	
	protected void setLayout(Object layout) {
		mLayout = layout;
	}
	/*=======================================================
	: ȡԸ
	:  
	ֵ: 
	======================================================*/
	public byte getExtendAttr() {
		return b7ExtendAttr;
	}
	/*=======================================================
	: øԵĸ
	:  
	ֵ: 
	======================================================*/
	public void setExtendAttr(byte b7ExtendAttr) {
		this.b7ExtendAttr = b7ExtendAttr;
	}
	
	/*=======================================================
	: ȡ
	:  
	ֵ: 
	======================================================*/
	public ArrayList<HFExtendAttr> getExtendAttrs() {
		return ExtendAttrs;
	}
	/*=======================================================
	: ø
	:  
	ֵ: 
	======================================================*/
	public void setExtendAttrs(ArrayList<HFExtendAttr> extendAttrs) {
		ExtendAttrs = extendAttrs;
	}
	
	/*=======================================================
	:ȡ̶״
	:  
	ֵ: 
	======================================================*/
	public boolean getFixedShapeEnabled(){
		if(ExtendAttrs != null){
			for(int i = 0; i < ExtendAttrs.size(); i++){
				HFExtendAttr item = ExtendAttrs.get(i);
				if(item.getType() == HFExtendAttrType.eExtendAttrType_BASFixedShape && item.getValue() > 0)
					return true;
			}
		}
		return false;
	}
	
	/*=======================================================
	:ù̶״
	:  
	ֵ: 
	======================================================*/
	public void setFixedShapeEnabled(boolean enabled){
		if(ExtendAttrs != null){
			for(int i = 0; i < ExtendAttrs.size(); i++){
				HFExtendAttr item = ExtendAttrs.get(i);
				if(item.getType() == HFExtendAttrType.eExtendAttrType_BASFixedShape)
					item.setValue(enabled?1:0);
			}
		}
	}
	
	/*=======================================================
	:ȡԲǰ뾶ֵ
	:  
	ֵ: 
	======================================================*/
	public int getRadius(){
		if(ExtendAttrs != null){
			for(int i = 0; i < ExtendAttrs.size(); i++){
				HFExtendAttr item = ExtendAttrs.get(i);
				if(item.getType() == HFExtendAttrType.eExtendAttrType_BTNRoundRadius && item.getValue() > 0)
					return item.getValue();
			}
		}
		return 0;
	}
	
	/*=======================================================
	:Բǰ뾶
	:  
	ֵ: 
	======================================================*/
	public void setRadius(int radius){
		if(ExtendAttrs != null){
			for(int i = 0; i < ExtendAttrs.size(); i++){
				HFExtendAttr item = ExtendAttrs.get(i);
				if(item.getType() == HFExtendAttrType.eExtendAttrType_BTNRoundRadius)
					item.setValue(radius);
			}
		}
	}
	
	public byte getVeiledEffect() {
		return b2VeiledEffect;
	}
	public void setVeiledEffect(byte b2VeiledEffect) {
		this.b2VeiledEffect = b2VeiledEffect;
	}
	
	/*=======================================================
	:ȡ߿ɫ
	:  
	ֵ: 
	======================================================*/
	public int getBorderColor(){
		if(ExtendAttrs != null){
			for(int i = 0; i < ExtendAttrs.size(); i++){
				HFExtendAttr item = ExtendAttrs.get(i);
				if(item.getType() == HFExtendAttrType.eExtendAttrType_BTNBorderColor && item.getValue() > 0)
					return item.getValue();
			}
		}
		return -1;
	}
	
	/*=======================================================
	:ñ߿ɫ
	:   
	ֵ: 
	======================================================*/
	public void setBorderColor(int color){
		if(ExtendAttrs != null){
			for(int i = 0; i < ExtendAttrs.size(); i++){
				HFExtendAttr item = ExtendAttrs.get(i);
				if(item.getType() == HFExtendAttrType.eExtendAttrType_BTNBorderColor)
					item.setValue(color);
			}
		}
	}

	public static class HFExtendAttr{
		 private int lType;   //
		 private int lValue;  //ֵ
		public int getType() {
			return lType;
		}
		public void setType(int lType) {
			this.lType = lType;
		}
		public int getValue() {
			return lValue;
		}
		public void setValue(int lValue) {
			this.lValue = lValue;
		}
	}
	
	public final static class HFExtendAttrType {
		public static final int eExtendAttrType_BTNRoundRadius = 0x01; //Բǰť뾶(ios)
		public static final int eExtendAttrType_BTNBorderColor = 0x02; //ť߿ɫ(ios)
		public static final int eExtendAttrType_BASFixedShape = 0x03;  //̶״ΣAndroid
	}
}
