package cnv.hf.widgets;

import android.database.DataSetObserver;
import android.view.View;
import android.view.ViewGroup;
import android.widget.ListAdapter;
import cnv.hf.widgets.HFListWidget.HFAdapterWidget;
import cnv.hf.widgets.HFListWidget.HFListItem;
import cnv.hf.widgets.HFListWidget.HFListItem.HFListItemType;
import cnv.hf.widgets.HFListWidget.HFListStyle;

public class HFDelegateWidget implements ListAdapter {
	
    private static final int TYPE_ITEM = 0;
    private static final int TYPE_SEPARATOR = 1;
    private static final int TYPE_MAX_COUNT = TYPE_SEPARATOR + 1;
	private HFListWidget mListView = null;
	
	public HFDelegateWidget(HFListWidget listView) {
		mListView = listView;
	}
	@Override
	public int getCount() {
		int count = 0;
		//ǹбعбĸӻصظ
		if(mListView.getListStyle() == HFListStyle.eListStyle_Feature) {
			count = mListView.getNumOfListItems();
		} else {
			HFAdapterWidget adapter = mListView.getAdapter();
			if(adapter != null) {
				count = adapter.getItemCount();
			}
		}
		return count;
	}
	@Override
	public Object getItem(int position) {
		// TODO Auto-generated method stub
		if(mListView.getListStyle() == HFListStyle.eListStyle_Feature) {
			return mListView.getItem(position);
		} else {
			return null;
		}		
	}
	@Override
	public long getItemId(int position) {
		// TODO Auto-generated method stub
		return 0;
	}

	@Override
	public int getItemViewType(int position) {
		// TODO Auto-generated method stub
		if(mListView.getListStyle() == HFListStyle.eListStyle_Feature) {
			 return ((mListView.getItem(position).getListItemType() == HFListItemType.eListItemType_Divider) ? TYPE_SEPARATOR : TYPE_ITEM);
		} else {
			return TYPE_ITEM;
		}			
	}

	@Override
	public View getView(int position, View convertView, ViewGroup parent) {
		// TODO Auto-generated method stub

		//бĴ
		if(mListView.getListStyle() == HFListStyle.eListStyle_Feature) {
			HFListItem listItem = mListView.getItem(position);
			if(listItem != null) {
				convertView = listItem.getLayerWidget();
			}
		} else {
			if(convertView == null) {
				HFListItem listItem = mListView.getItem(0);
				if(listItem != null) {
					HFLayerWidget layer = listItem.getLayerWidget();
					//cloneһͼ
					convertView = layer.clone();			
				}
			}
		}
		//бΪգûص
		if(convertView != null) {
			((HFLayerWidget)convertView).setDescendantFocusability(ViewGroup.FOCUS_BLOCK_DESCENDANTS);
			HFAdapterWidget adapter = mListView.getAdapter();
			if(adapter != null) {
				adapter.getItemData(position, convertView);
			}	
		}		
		return convertView;
	}
	@Override
	public int getViewTypeCount() {
		// TODO Auto-generated method stub
		return TYPE_MAX_COUNT;
	}
	@Override
	public boolean hasStableIds() {
		// TODO Auto-generated method stub
		return false;
	}
	@Override
	public boolean isEmpty() {
		// TODO Auto-generated method stub
		return false;
	}
	@Override
	public void registerDataSetObserver(DataSetObserver observer) {
		// TODO Auto-generated method stub
	}
	@Override
	public void unregisterDataSetObserver(DataSetObserver observer) {
		// TODO Auto-generated method stub
	}
	@Override
	public boolean areAllItemsEnabled() {
		// TODO Auto-generated method stub
		return false;
	}
	@Override
	public boolean isEnabled(int position) {
		// TODO Auto-generated method stub
		return true;
	}

}
