package cnv.hf.widgets;

import java.util.ArrayList;

import android.content.Context;
import android.view.MotionEvent;
import android.view.View;
import android.view.View.OnTouchListener;
import android.widget.FrameLayout;
import android.widget.LinearLayout;
import android.widget.RadioButton;
import android.widget.TabHost;
import android.widget.TabHost.TabContentFactory;
import android.widget.TabHost.TabSpec;
import android.widget.TabWidget;
import cnv.hf.widgets.HFWidgetStorage.HFTabBarStorage;
import cnv.hf.widgets.HFWidgetStorage.HFTabItemStorage;

public class HFTabBarWidget extends HFBaseWidget{
	
	private int tabStyle;						 //tabҳķ (֧ڵײַ)
	private ArrayList<HFTabItem> mTabItems = null; //洢Tabҳ
	
	public HFTabBarWidget(Context context, Object widgetData) {
		super(context, widgetData);
		//洢Tabҳݵ
		mTabItems = new ArrayList<HFTabItem>();
		//ʼ
		initTabBarMembers(widgetData);
	}
	@Override
	protected void setHolder(Context context,Object widgetData) {
				
        TabHost tabHost = new TabHost(context);
        tabHost.setId(android.R.id.tabhost);

        TabWidget widget = new TabWidget(context);
        widget.setId(android.R.id.tabs);

        FrameLayout content = new FrameLayout(context);
        content.setId(android.R.id.tabcontent);

        LinearLayout layout = new LinearLayout(context);
        layout.setOrientation(LinearLayout.VERTICAL);
        layout.addView(widget);
        layout.addView(content);     
        tabHost.addView(layout);
        tabHost.setup();
        setObject(tabHost);
	}
	/*======================================================
	: ʼTab
	:  widgetData [in] TabBarĳʼ
	ֵ: 
	======================================================*/
	private void initTabBarMembers(Object widgetData) {

		HFTabBarStorage pData = (HFTabBarStorage)widgetData;
		if(pData != null) {
			//TabBarķ
			setTabStyle(pData.getTabStyle());
			//ʼTabҳ
			TabContentMethodFactory methodFactory = new TabContentMethodFactory(this);
			for(int index=0; index<pData.getNumOfTabs(); index++) {
				HFTabItem tabitem = new HFTabItem(getObject().getContext(), pData.getTab(index));
				mTabItems.add(tabitem);
				addTab(tabitem.getName(), tabitem.getTabWidget(), methodFactory);
			}
		}
	}
	/*======================================================
	: һtabҳ
	:  tab           [in] ҪӵTabҳ
	ֵ: 
	======================================================*/
	public void addTab(TabSpec tabSpec){
		TabHost tabHost = (TabHost)getObject();
		if(tabHost != null) {
			tabHost.addTab(tabSpec);
		}
	}	
	/*======================================================
	: һtabҳ
	:  tag            [in] ҪӵTabҳıǩ
	       indicator      [in] ҪӵTabҳindicator
	       contentFactory [in] ҪӵTabҳcontentFactory
			
	ֵ: 
	======================================================*/
	public void addTab(String tag, HFLayerWidget indicator, TabContentFactory contentFactory){
		TabHost tabHost = (TabHost)getObject();
		if(tabHost != null && indicator != null && contentFactory != null) {
			indicator.setTag(tag);
			setOnTabTouchListener(indicator, mOnTabTouchListener);
			//TabSpec tabSpec = tabHost.newTabSpec(tag).setIndicator(indicator).setContent(contentFactory);
			TabSpec tabSpec = tabHost.newTabSpec(tag);
			tabSpec.setIndicator(indicator);
			tabSpec.setContent(contentFactory);
			tabHost.addTab(tabSpec);
		}
	}		
	/*======================================================
	: һtab
	:  tab           [in] ҪӵTabҳ
	ֵ: 
	======================================================*/
	public TabSpec newTab(String tag){
		TabSpec tabSpec = null;
		TabHost tabHost = (TabHost)getObject();
		if(tabHost != null) {
			tabSpec = tabHost.newTabSpec(tag);
		}
		return tabSpec;
	}	
	/*======================================================
	: ȡǰTabҳ
	:  widget                [in] ؼָ
	ֵ: -1 ʧ >=0 Tabҳ 
	======================================================*/
	public int getCurrentTabIndex() {
		TabHost tabHost = (TabHost)getObject();
		if(tabHost != null) {
			return tabHost.getCurrentTab();
		}
		return -1;
	}
	/*======================================================
	: õǰTabҳ
	:  index             [in] Tabҳ
	ֵ: 
	======================================================*/
	public void setCurrentTabIndex(int index) {

		TabHost tabHost = (TabHost)getObject();
		if(tabHost != null) {
			if(index > -1 && index < tabHost.getTabWidget().getChildCount()) {
				tabHost.setCurrentTab(index);
				setTabSelected(getTab(index));
			}
		}	
	}	
	/*======================================================
	: õǰTabҳ
	:  index             [in] Tabҳ
	ֵ: 
	======================================================*/
	public void setCurrentTabIndex(String tag) {
		setCurrentTabIndex(getTabIndex(tag));
	}		
	/*======================================================
	: ȡTabҳ
	:  
	ֵ:Tabҳ
	======================================================*/
	public int getNumOfTabs() {
		TabHost tabHost = (TabHost)getObject();
		if(tabHost != null && tabHost.getTabWidget() != null) {
			return tabHost.getTabWidget().getChildCount();
		}
		return 0;
	}
	/*======================================================
	: ͨTagȡTabҳindicator
	:  tag [in] tag
	ֵ:Tabҳindicator
	======================================================*/	
	public HFLayerWidget findTab(String tag) {
		
		TabHost tabHost = (TabHost)getObject();
		if(tabHost != null && tabHost.getTabWidget() != null) {		
			for(int index = 0; index<tabHost.getTabWidget().getChildCount(); index++) {
				String string = (String)tabHost.getTabWidget().getChildAt(index).getTag();
				if(string != null && string.compareTo(tag) == 0) {
					return (HFLayerWidget) tabHost.getTabWidget().getChildAt(index);
				}
			}
		}
		return null;
	}
	/*======================================================
	: ͨIndexȡTabҳindicator
	:  index [in] 
	ֵ:Tabҳindicator
	======================================================*/	
	public HFLayerWidget getTab(int index) {
		TabHost tabHost = (TabHost)getObject();
		if(tabHost != null && tabHost.getTabWidget() != null) {		
			if(index > -1 && index < tabHost.getTabWidget().getChildCount()) {
				return (HFLayerWidget) tabHost.getTabWidget().getChildAt(index);
			}
		}
		return null;
	}
	/*======================================================
	: ͨTagȡTabҳindicator
	:  tag [in] tag
	ֵ:Tabҳindicator
	======================================================*/	
	public int getTabIndex(String tag) {
		TabHost tabHost = (TabHost)getObject();
		if(tabHost != null && tabHost.getTabWidget() != null) {	
			for(int index = 0; index<tabHost.getTabWidget().getChildCount(); index++) {
				String string = (String) tabHost.getTabWidget().getChildAt(index).getTag();
				if(string != null && string.compareTo(tag) == 0) {
					return index;
				}
			}
		}
		return -1;
	}	
	/*======================================================
	: ͨTagTabҳindicatorǷɼ
	:  tag [in] tag
	ֵ:
	======================================================*/	
	public void setTabVisible(String tag, boolean visible) {
		
		int visibility = (visible) ? View.VISIBLE: View.INVISIBLE;
		int index = this.getTabIndex(tag);
		if(index == -1) {
			return;
		}
		TabHost tabHost = (TabHost)getObject();
		if(tabHost == null) {
			return ;
		}
		TabWidget tabWidget = tabHost.getTabWidget();
		if(tabWidget != null && index < tabWidget.getChildCount()) {
			tabWidget.getChildAt(index).setVisibility(visibility);
		}
		FrameLayout tabContent = tabHost.getTabContentView();
		if(tabContent != null && index < tabContent.getChildCount()) {
			tabContent.getChildAt(index).setVisibility(visibility);
		}
	}
	/*======================================================
	: ͨTagɾindicator
	:  tag [in] tag
	ֵ:
	======================================================*/	
	public void removeTab(String tag) {
		TabHost tabHost = (TabHost)getObject();
		if(tabHost == null) {
			return ;
		}
		int index = getTabIndex(tag);
		if(index > -1 && index < tabHost.getTabWidget().getChildCount()) {
			tabHost.getTabWidget().removeViewAt(index);
		}
/*		
		if(index > -1 && index < tabHost.getTabContentView().getChildCount() ) {
			String string = (String)tabHost.getChildAt(index).getTag(); 
			if(string.compareTo(tag) == 0) {
				tabHost.getTabContentView().removeViewAt(index);
			}	
		}
*/		
	}
	/*======================================================
	: ͨTagɾindicator
	:  
	ֵ:
	======================================================*/	
	public void removeAllTabs() {
		TabHost tabHost = (TabHost)getObject();
		if(tabHost != null) {
			tabHost.getTabWidget().removeAllViewsInLayout();
			tabHost.getTabContentView().removeAllViewsInLayout();
		}
	}
	/*======================================================
	: indicatorlistener
	:  indicator [in] indicator
	       listener  [in] 
	ֵ:
	======================================================*/		
	private void setOnTabTouchListener(HFLayerWidget tab, OnTouchListener listener) {
		int index;
		if(tab != null & listener != null) {
			for(index = 0; index < tab.getNumOfWidgets(); index++) {
				HFBaseWidget widget = tab.getWidgetByIndex(index);
				if(widget != null && widget instanceof HFRadioButtonWidget) {
					View view = (View)widget.getObject();
					if(view != null) {
						view.setOnTouchListener(listener);
					}
				}
			}
		}
	}
	/*======================================================
	: indicatorıѡ
	:  indicator [in] indicator
	ֵ:
	======================================================*/		
	private void setTabSelected(HFLayerWidget tab) {
		int index;
		if(tab != null) {
			for(index = 0; index < tab.getNumOfWidgets(); index++) {
				HFBaseWidget widget = tab.getWidgetByIndex(index);
				if(widget != null && widget instanceof HFRadioButtonWidget) {
					RadioButton radioButton = (RadioButton)widget.getObject();
					if(radioButton != null && radioButton.isChecked() == false) {
						radioButton.setChecked(true);
					}
				}
			}
		}
	}
	/*======================================================
	: ͨtagȡǰtabContent
	:  tag [in] tagֵ
	ֵ: content
	======================================================*/
	private HFLayerWidget findTabContentByTag(String tag) {
		
		HFTabItem tabItem = null;
		
		for(int index = 0; index < mTabItems.size(); index++) {
			tabItem = mTabItems.get(index);
			if(tabItem.getName() != null && tabItem.getName().compareTo(tag) == 0) {
				return tabItem.getTabcontent();
			}
		}
		return null;
	}
	/*======================================================
	: ȡǰTabbarķ
	:  
	ֵ: tabBarķ(ײ)
	======================================================*/		
	public int getTabStyle() {
		return tabStyle;
	}
	/*======================================================
	: õǰTabbarķ
	:  tabStyle [in] tabBarķ(ײ)
	ֵ: 
	======================================================*/	
	public void setTabStyle(int tabStyle) {
		this.tabStyle = tabStyle;
	}
	/*======================================================
	: ػIndicatorOnTouch¼
	:  
	ֵ:
	======================================================*/	
	private OnTouchListener mOnTabTouchListener = new OnTouchListener() {
		@Override
		public boolean onTouch(View v, MotionEvent event) {
			if (event.getAction()==MotionEvent.ACTION_UP) {
		
				HFLayerWidget indicator = (HFLayerWidget) v.getParent();
				setCurrentTabIndex(((String)indicator.getTag()));
			}			
			return false;
		}
	};
	/*======================================================
	: TabҳContentĽӿ
	:  tag [in] tabҳtag
	ֵ:
	======================================================*/
	private class TabContentMethodFactory implements TabContentFactory {
		
		private Object mObject = null;
		
		public TabContentMethodFactory(Object object) {
			mObject = object;
		}
		@Override
		public View createTabContent(String tag) {
			// TODO Auto-generated method stub
			
			HFTabBarWidget tabBar = (HFTabBarWidget)mObject;
			if(tabBar != null) {
				return tabBar.findTabContentByTag(tag);
			}
			return null;
		}
	}
	//Tabඨ
	protected class HFTabItem extends HFBaseWidget{
		
		private HFLayerWidget mTabWidget;	//ָʾ(ǩ)--ͼId		
		private HFLayerWidget mTabcontent;	//ʾ--ͼId
		
		public HFTabItem(Context context, Object widgetData) {
			super(context, widgetData);
			
			initTabItemMembers(context, widgetData);
		}
		public HFLayerWidget getTabWidget() {
			return mTabWidget;
		}
		public void setTabWidget(HFLayerWidget tabWidget) {
			this.mTabWidget = tabWidget;
		}
		public HFLayerWidget getTabcontent() {
			return mTabcontent;
		}
		public void setTabcontent(HFLayerWidget tabcontent) {
			this.mTabcontent = tabcontent;
		}
		private void initTabItemMembers(Context context, Object widgetData) {
			
			HFTabItemStorage pData = (HFTabItemStorage)widgetData;
			if(pData != null && context != null) {
				//setTabWidget(findLayerById(context, pData.getTabWidgetId()));
				//setTabcontent(findLayerById(context, pData.getTabcontentId()));
				HFLayerWidget tabWidget = createLayerById(context, pData.getTabWidgetId());
				if(tabWidget != null) {
					setName(tabWidget.getName());
					setTabWidget(tabWidget);
				}
				setTabcontent(createLayerById(context, pData.getTabcontentId()));					
			}
		}		
		/*======================================================
		: ͨͼIdȡͼ
		:  
				Id   [in] ͼId
		
		ֵ: ͼ
		======================================================*/
		protected HFLayerWidget findLayerById(Context context, int layerId) {
		
			HFModeWidget modeWidget = (HFModeWidget)(context);
			if(modeWidget != null) {
				return modeWidget.findLayerById(layerId);
			}
			return null;
		}	
		/*======================================================
		: ͨͼIdȡͼ
		:  
				Id   [in] ͼId
		
		ֵ: ͼ
		======================================================*/
		protected HFLayerWidget createLayerById(Context context, int layerId) {
		
			HFModeWidget modeWidget = (HFModeWidget)(context);
			if(modeWidget != null) {
				return modeWidget.createLayerWidgets(layerId);
			}
			return null;
		}
	}
}
