package cnv.hf.widgets;

import java.lang.reflect.Field;

import android.content.Context;
import android.content.res.ColorStateList;
import android.graphics.Color;
import android.graphics.Paint;
import android.graphics.Rect;
import android.graphics.Typeface;
import android.text.TextUtils;
import android.util.TypedValue;
import android.view.Gravity;
import android.widget.EditText;
import android.widget.TextView;
import cnv.hf.widgets.HFLabelWidget.Ellipsize;
import cnv.hf.widgets.HFLabelWidget.Marquee;
import cnv.hf.widgets.HFModesManager.HFOrientation;
import cnv.hf.widgets.HFWidgetStorage.HFBaseStorage;
import cnv.hf.widgets.HFWidgetStorage.HFTextItemStorage;

public class HFTextItem extends HFBaseWidget {
	
	private HFWidgetRect     textMargin;      		/*ıĻ*/	
	private HFWidgetFont     textFont;		  		/**/			
	private int            	 normalColor  = 0;     /*ɫ*/		
	private int            	 clickColor   = 0;     /*ɫ*/		
	private int              focusColor   = 0;     /*ɫ*/		
	private int              selectedColor= 0;     /*ɫ*/		
	private int              disableColor = 0;     /*ɫ*/		
	private short            textAlign;       		/*뷽ʽ*/	
	//ַ
	private CharSequence portraitText = null;
	//ַ
	private CharSequence landscapeText = null;
	/** ǷҪתĻʱԶı */
	private boolean autoSetText = true;               //ǷҪתĻʱԶı
	private Paint mPaint;
	
	/*======================================================
	: Ĺ캯
	: Context 		[in] Context
	      widgetData 	[in] 	
	ֵ: 
	======================================================*/
	public HFTextItem(Context context, Object widgetData) {
		super(context, widgetData);
		//ʼı
		initTextItemMembers(widgetData);
	}
	/*======================================================
	: ʼؼ
	: 
	ֵ: 
	======================================================*/
	private void initTextItemMembers(Object widgetData) {
		HFTextItemStorage data = (HFTextItemStorage)widgetData;	
		if(data != null) {
			setMargin(data.getMargin());
			//convertFont(data.getFont());
			setFont(data.getFont());
//			if(data.getNormalColor() != -1) {
//				setNormalColor(convert2ARGB(data.getNormalColor()));
//			}
//			if(data.getClickColor() != -1) {
//				setClickColor(convert2ARGB(data.getClickColor()));
//			}
//			if(data.getFocusColor() != -1) {
//				setFocusColor(convert2ARGB(data.getFocusColor()));
//			}
//			if(data.getDisableColor() != -1) {
//				setDisableColor(convert2ARGB(data.getDisableColor()));
//			}
			setNormalColor(data.getNormalColor());//convert2ARGB(data.getNormalColor()));
			setClickColor(data.getClickColor());//convert2ARGB(data.getClickColor()));
			setFocusColor(data.getFocusColor());//convert2ARGB(data.getFocusColor()));
			setDisableColor(data.getDisableColor());//convert2ARGB(data.getDisableColor()));
			setSelectedColor(data.getFocusColor());
			
			//ʱøԵborder colorΪ༭hintɫ
			if(this instanceof HFEditWidget){
				int color = data.getBorderColor();
				if(color != -1){
					//ɫֵתΪRGBɫֵ
					int blue = (color & 0x000000FF);
					int green = ((color>>8) & 0x000000FF);
					int red = ((color>>16) & 0x000000FF);
					((HFEditWidget)this).setHintTextColor(Color.rgb(red, green, blue));	
				}
			}
			
			//ıĶ뷽ʽ
			setAlign(data.getAlign());
			//ı
			setText(data.getText());
			
		}
	}
	/*======================================================
	: ȡԱTextView
	: 
	ֵ: TextViewؼ
	======================================================*/
	protected TextView getTextView() {
		return (TextView)getObject();
	}
	/*======================================================
	: ȡTextViewı
	: 
	ֵ: ı
	======================================================*/
	public CharSequence getText() {
		return getTextView().getText();
	}
	/*======================================================
	: TextViewı
	: text [in] Ҫõı
	ֵ: 
	======================================================*/
	public void setText(CharSequence text) {
		if(HFModesManager.getOrientation() == HFOrientation.eOrientation_Portrait)
			portraitText = text;
		else if(HFModesManager.getOrientation() == HFOrientation.eOrientation_Landscape)
		{
			landscapeText = text;
		}
		getTextView().setText(text);
	}
	/*======================================================
	: TextViewı
	: text [in] Ҫõı
	     alignCenter [in] ıʾ
	ֵ: 
	======================================================*/
	public void setText(CharSequence text,boolean alignCenter) {
		CharSequence lastText = null;
		if(HFModesManager.getOrientation() == HFOrientation.eOrientation_Portrait){
			lastText = portraitText;
			portraitText = text;
		}
		else if(HFModesManager.getOrientation() == HFOrientation.eOrientation_Landscape)
		{
			lastText = landscapeText;
			landscapeText = text;
		}
		if(alignCenter){
		
			//ͼƬλü߾
			int move = getDifWidth(lastText, text, (int) getTextView().getTextSize());
//			int move = (int) (getTextView().getTextSize() * (text.length() - lastText.length()) / 2 + 0.5);
			if(this instanceof HFButtonWidget){
				HFButtonWidget buttonWidget = (HFButtonWidget) this;
				buttonWidget.moveImageList(move, 0);
			}
			TextView txt = getTextView();
			txt.setPadding(txt.getPaddingLeft() - move, txt.getPaddingTop(), txt.getPaddingRight(),
					txt.getPaddingBottom());
		}
		
		getTextView().setText(text);
	}
	/*======================================================
	: ȡıMargin
	: 
	ֵ: Margin
	======================================================*/
	public HFWidgetRect getMargin() {
		
		return textMargin;
	}
	
	public void setEnabled(boolean enabled) {
		super.setEnabled(enabled);
		setTextColor();
	}
	/*======================================================
	: ıMargin
	:  textMargin    [in] Margin
	ֵ: 
	======================================================*/
	public void setMargin(HFWidgetRect textMargin) {
		this.textMargin = textMargin;
		HFWidgetBound bound = this.getBound();	
		if(textMargin != null && bound != null) {
			//ͨıλúBoundľ룬paddingʵֵ
			int left = textMargin.getLeft() - bound.getLeft();
			int top = textMargin.getTop() - bound.getTop();
			int right = bound.getLeft() + bound.getWidth() - 1 - textMargin.getRight();
			int bottom = bound.getTop() + bound.getHeight() - 1 - textMargin.getBottom();
			left = left < 0?0:left;
			top = top < 0?0:top;
			right = right < 0?0:right;
			bottom = bottom < 0?0:bottom;
			getTextView().setPadding(left, top, right, bottom);
		}	
	}
	/*======================================================
	: ȡؼ
	:  
	ֵ: 
	======================================================*/
	public HFWidgetFont getFont() {
		return textFont;
	}
	/*======================================================
	: ķ
	:  textFont [in] ķ
	ֵ: 
	======================================================*/
	private void setFontStyle(HFWidgetFont textFont) {
		TextView tv = getTextView();
		if(tv != null && textFont != null) { 
			Typeface typeFace = null;
			switch(textFont.getTypeface()) {
				case HFTextTypeFace.eTypeface_Normal:
					typeFace = Typeface.DEFAULT;
					break;
				case HFTextTypeFace.eTypeface_Song:
					typeFace = Typeface.create("", Typeface.NORMAL);
					break;
				default:
					typeFace = Typeface.DEFAULT;
					break;
			}
			if(typeFace == null) {
				typeFace = Typeface.DEFAULT;
			}
			switch(textFont.getStyle()) {
				case HFFontStyle.eFontStyle_Normal:
					//tv.setTypeface(typeFace,Typeface.NORMAL);
					break;
				case HFFontStyle.eFontStyle_Bold:
					tv.setTypeface(typeFace, Typeface.BOLD);
					break;
				case HFFontStyle.eFontStyle_Italic:
					tv.setTypeface(typeFace,Typeface.ITALIC);
					break;
				case HFFontStyle.eFontStyle_Bold_Italic:
					tv.setTypeface(typeFace,Typeface.BOLD_ITALIC);
					break;	
				default: 
					//tv.setTypeface(typeFace,Typeface.NORMAL);
					break;
			} 
		}
	}
	/*======================================================
	: תĴСpxspλ 
	: textFont      [in] 
	ֵ: 
	======================================================*/
	public void convertFont(HFWidgetFont textFont) {
		if(textFont != null) {
			float fontSize = HFUnitsUtils.px2sp(textFont.getSize()); 
			textFont.setSize(fontSize);
		}
	}	
	/*======================================================
	: ÿؼ 
	: textFont      [in] 
	ֵ: 
	======================================================*/
	public void setFont(HFWidgetFont textFont) {
		this.textFont = textFont;
		if(textFont != null) {
			setFontStyle(textFont);
			getTextView().setTextSize(TypedValue.COMPLEX_UNIT_PX,textFont.getSize());
		}
	}
	/*======================================================
	: ȡɫ
	: 
	ֵ: ɫֵ
	======================================================*/	
	public int getNormalColor() {
		return normalColor;
	}
	/*======================================================
	: ɫ
	:  normalColor    [in] ɫ
	ֵ: 
	======================================================*/
	public void setNormalColor(int normalColor) {
		this.normalColor = normalColor;
		setTextColor();
	}
	/*======================================================
	: ȡʱɫ
	: 
	ֵ: ɫֵ
	======================================================*/
	public int getClickColor() {
		return clickColor;
	}
	/*======================================================
	: õʱɫ
	:  clickColor    [in] ɫ
	ֵ: 
	======================================================*/
	public void setClickColor(int clickColor) {
		this.clickColor = clickColor;
		setTextColor();
	}
	/*======================================================
	: ȡʱɫ
	: 
	ֵ: ɫֵ
	======================================================*/
	public int getFocusColor() {
		return focusColor;
	}
	/*======================================================
	: ýʱɫ
	:  focusColor    [in] ɫ
	ֵ: 
	======================================================*/
	public void setFocusColor(int focusColor) {
		this.focusColor = focusColor;
		setTextColor();
	}
	/*======================================================
	: ȡѡʱɫ
	: 
	ֵ: ɫֵ
	======================================================*/
	public int getSelectedColor() {
		return selectedColor;
	}
	/*======================================================
	: ѡʱɫ
	:  selectedColor    [in] ɫ
	ֵ: 
	======================================================*/
	public void setSelectedColor(int selectedColor) {
		this.selectedColor = selectedColor;
		setTextColor();
	}
	/*======================================================
	: ȡʱɫ
	: 
	ֵ: ɫֵ
	======================================================*/
	public int getDisableColor() {
		return disableColor;
	}
	/*======================================================
	: ýʱɫ
	:  
	       disableColor    [in] ɫ
	       
	ֵ: 
	======================================================*/
	public void setDisableColor(int disableColor) {
		this.disableColor = disableColor;
		setTextColor();
	}
	/*======================================================
	: ȡؼĳ
	: 
	ֵ: ؼĶ뷽ʽ(ǶenumNAVI_HF_ALIGNMENT)
	======================================================*/
	public int getAlign() {
		return textAlign ;
	}
	/*======================================================
	: ÿؼĳ
	:  in_uiTextAlign   [in] ɫ, enumNAVI_HF_ALIGNMENT
	ֵ: 
	======================================================*/
	public void setAlign(int align) {
		
		this.textAlign  = (short) align;
		int gravity = Gravity.NO_GRAVITY;
		if((align & HFTextAlignment.eAlignment_HoriCenter) == HFTextAlignment.eAlignment_HoriCenter) {
			gravity |= Gravity.CENTER_HORIZONTAL;
		}
		else if((align & HFTextAlignment.eAlignment_HoriRight) == HFTextAlignment.eAlignment_HoriRight)	{
			gravity |= Gravity.RIGHT;
		}
		else {
			gravity |= Gravity.LEFT;
		}
		if((align & HFTextAlignment.eAlignment_VeriCenter) == HFTextAlignment.eAlignment_VeriCenter) {
			gravity |= Gravity.CENTER_VERTICAL;
		}
		else if((align & HFTextAlignment.eAlignment_VeriBottom) == HFTextAlignment.eAlignment_VeriBottom)	{
			gravity |= Gravity.BOTTOM;
		}
		else {
			gravity |= Gravity.TOP;
		}
		
		this.getTextView().setGravity(gravity);
	}
	
	/*======================================================
	: ı
	:  residԴID
	ֵ: 
	======================================================*/
	public void setCursorResource(int resid){
		Object mView = getObject();
		if(mView != null){
			Class<?> classType = null;
			if(mView instanceof EditText){
				classType = mView.getClass();
				classType = classType.getSuperclass();
			}
			else if(mView instanceof TextView){
				classType = mView.getClass();
			}
				
			try {
				 if(classType != null)
				 {
					 Field mCursorDrawableRes = classType.getDeclaredField("mCursorDrawableRes");
					 if(mCursorDrawableRes != null){
						 mCursorDrawableRes.setAccessible(true);
						 mCursorDrawableRes.setInt(mView, resid);
					 }
				 }
				 
			} catch (SecurityException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			} catch (NoSuchFieldException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			} catch (IllegalArgumentException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			} catch (IllegalAccessException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			}
		}
	}
	/*======================================================
	: ȡıɫ
	:  
	ֵ: ıɫ
	======================================================*/
	private  ColorStateList getColorStateList() {
		
		int index = 0;
		int[] colors = null; 
		int[][] states = null;
		ColorStateList colorList = null;
		
		if(normalColor != 0 && clickColor != 0 && focusColor != 0 && disableColor != 0) {
			
			colors = new int[7]; 
			states = new int[7][];
			
			states[index] = new int[] { android.R.attr.state_pressed, android.R.attr.state_enabled };
			colors[index++] = clickColor;
			
			states[index] = new int[] { android.R.attr.state_enabled, android.R.attr.state_selected };
			colors[index++] = focusColor;
			
			states[index] = new int[] { android.R.attr.state_enabled, android.R.attr.state_focused };
			colors[index++] = focusColor;
			
			states[index] = new int[] { android.R.attr.state_enabled };
			colors[index++] = normalColor;
			
			states[index] = new int[] { android.R.attr.state_focused };
			colors[index++] = focusColor;
			
			states[index] = new int[] { android.R.attr.state_window_focused };
			colors[index++] = disableColor;
			
			states[index] = new int[] {};
			if(this.getObject().isEnabled() == false)
			   colors[index++] = disableColor;
			else
			   colors[index++] = normalColor;
			
			
			colorList = new ColorStateList(states, colors);
		}else if(normalColor != 0 && clickColor != 0 && focusColor != 0) {
			
			colors = new int[7]; 
			states = new int[7][];
			
			states[index] = new int[] { android.R.attr.state_pressed, android.R.attr.state_enabled };
			colors[index++] = clickColor;
			
			states[index] = new int[] { android.R.attr.state_enabled, android.R.attr.state_selected };
			colors[index++] = focusColor;
			
			states[index] = new int[] { android.R.attr.state_enabled, android.R.attr.state_focused };
			colors[index++] = focusColor;
			
			states[index] = new int[] { android.R.attr.state_enabled };
			colors[index++] = normalColor;
			
			states[index] = new int[] { android.R.attr.state_focused };
			colors[index++] = focusColor;
			
			states[index] = new int[] { android.R.attr.state_window_focused };
			colors[index++] = normalColor;
			
			states[index] = new int[] {};
			colors[index++] = normalColor;	
			
			colorList = new ColorStateList(states, colors);
		}		
		return colorList;
	}
	/*======================================================
	: ıɫ
	:  
	ֵ: ıɫ
	======================================================*/
	private  void setTextColor() {
	
		TextView tv = getTextView();
		if(tv != null) {
			ColorStateList colors = getColorStateList();
			if(colors != null) {
				tv.setTextColor(colors);
			}
			else 
			if(normalColor != 0){
				tv.setTextColor(normalColor);
			}
		}	
	}
	
	/*======================================================
	: ÿؼĶ
	:  in_cMutiLines    [in] 
	
	ֵ: 
	======================================================*/
	public void setMultiLines(boolean bMultiLines) {
		TextView tv = this.getTextView();
		if(tv == null) {
			return;
		}	
		if(bMultiLines  == true) {
			tv.setMaxLines(128);
			//setSingleLineʾ
			tv.setSingleLine(false);
		} else {
			tv.setSingleLine();
		}
	}
	
	/*======================================================
	: ÿؼĳʡ
	: 
	       in_eEllipsize    [in] ʡ
	ֵ: 
	======================================================*/
	public void setEllipsize(int ellipsize) {
		TextView tv = this.getTextView();
		if(tv == null) {
			return;
		}	
		switch(ellipsize) {
			case Ellipsize.eEllipize_Truncate:
				tv.setEllipsize(null);
				break;
			case Ellipsize.eEllipize_Start:
				tv.setEllipsize(TextUtils.TruncateAt.valueOf("START"));
				tv.setSingleLine();
				break;
			case Ellipsize.eEllipize_Middle:
				tv.setEllipsize(TextUtils.TruncateAt.valueOf("MIDDLE"));
				tv.setSingleLine();
				break;
			case Ellipsize.eEllipize_End:
				tv.setEllipsize(TextUtils.TruncateAt.valueOf("END"));
				tv.setSingleLine();
				break;	
			case Ellipsize.eEllipize_Marquee:
				if(this instanceof HFLabelWidget){
				  ((HFLabelWidget)(this)).setMarquee(Marquee.eMarquee_Reciprocating);
				}
				break;					
		}
	}
	/*======================================================
	: ʵֿؼĺл
	: 	widgetData  [in] ؼ
	ֵ: =0: лɹ; >0: 
	======================================================*/
    @Override
	protected int changeOrientation(HFBaseStorage widgetData) {
    	super.changeOrientation(widgetData);
    	HFTextItemStorage pData = (HFTextItemStorage) widgetData;
		if(pData != null) {
			setMargin(pData.getMargin());
			setAlign(pData.getAlign()); 
			setTextColor();
			setFont(pData.getFont());//С
			if(autoSetText){
				if(HFModesManager.getOrientation() == HFOrientation.eOrientation_Portrait)
				{
					if(null == portraitText)
						portraitText = pData.getText();
					if(getTextView().getText() != null)
						portraitText = getTextView().getText();
					setText(portraitText);
				}
				else if(HFModesManager.getOrientation() == HFOrientation.eOrientation_Landscape)
				{
					if(null == landscapeText)
						landscapeText = pData.getText();
					if(getTextView().getText() != null)
						landscapeText = getTextView().getText();
					setText(landscapeText);
				}
			}
		}
		return 0;
	}
	/*======================================================
	: ʵֿؼĺл
	: 	widget  [in] ؼ
	ֵ: =0: лɹ; >0: 
	======================================================*/
    @Override
	protected int changeOrientation(HFBaseWidget widget) {
    	super.changeOrientation(widget);
    	HFTextItem pBase = (HFTextItem) widget;
		if(pBase != null) {
			setMargin(pBase.getMargin());
		}
		return 0;
	}		
	//
	public final class  HFTextTypeFace {
		public static final char eTypeface_Normal       = 0x00; 	//(Ĭ)
		public static final char eTypeface_Song         = 0x01;  	//
	}
	//
	public final class HFFontStyle {
		public static final char eFontStyle_Normal       = 0x00; //
		public static final char eFontStyle_Bold         = 0x01; //
		public static final char eFontStyle_Italic       = 0x02; //б
		public static final char eFontStyle_Bold_Italic  = 0x03;  //塢б
	}
	//뷽ʽ
	public final class HFTextAlignment {
		public static final char eAlignment_Defult		= 0;	//Ͻʾı
		public static final char eAlignment_HoriCenter	= 1;	//ˮƽʾı
		public static final char eAlignment_VeriCenter	= 2;	//ֱʾı
		public static final char eAlignment_HoriRight	= 4;	//Ҷʾı
		public static final char eAlignment_VeriBottom	= 8;	//½ʾı
	} 
	
	/**
	 * ȡı任ǰĿȲ
	 * 
	 * @param lastTxt
	 * @param newTxt
	 * @param textSize
	 * @return
	 * @return int
	 * @author LiangYJ
	 * @date 2015-9-23 11:14:47
	 */
	private int getDifWidth(CharSequence lastTxt,CharSequence newTxt,int textSize) {
		if(mPaint == null){
			mPaint = new Paint();
			mPaint.setStyle(Paint.Style.FILL);
			mPaint.setAntiAlias(true);// ȥ
			mPaint.setColor(Color.WHITE);// ɫ
			mPaint.setTextAlign(Paint.Align.CENTER);
		}
		mPaint.setTextSize(textSize);

		float lastWidth = mPaint.measureText(lastTxt.toString());
		float newWidth = mPaint.measureText(newTxt.toString());
//		Rect newRect = new Rect();
//		mPaint.getTextBounds(newTxt.toString(), 0, newTxt.length(), newRect);
//
//		Rect lastRect = new Rect();
//		mPaint.getTextBounds(lastTxt.toString(), 0, lastTxt.length(), lastRect);
//		return (int) ((newRect.width() - lastRect.width())/2+0.5);
		return (int) ((newWidth - lastWidth)/2 + 0.5);
	}
	

	/** ǷתĻʱԶı
	 * @param autoSetText
	 * @return void
	 * @author LiangYJ
	 * @date 20151117 2:29:41
	 */ 
	public void setAutoSetText(boolean autoSetText) {
		this.autoSetText = autoSetText;
	}
	
	
}
