package cnv.hf.widgets;

import java.io.UnsupportedEncodingException;
import java.util.ArrayList;

import cnv.hf.widgets.HFBaseObject.HFExtendAttrType;
import cnv.hf.widgets.HFWidgetStorage.HFExtendAttrStorage;
import cnv.hf.widgets.HFWidgetStorage.HFExtendMeta;

public class HFWidgetStorage {
	//ṹ
	public static class HFPointStorage {
		private short x;
		private short y;
		public short getX() {
			return x;
		}
		public void setX(short x) {
			this.x = x;
		}
		public short getY() {
			return y;
		}
		public void setY(short y) {
			this.y = y;
		}
	}	
	//ExtendAttr
	public static class HFExtendAttrStorage{
		 private int lType;   //
		 private int lValue;  //ֵ
		public int getType() {
			return lType;
		}
		public void setType(int lType) {
			this.lType = lType;
		}
		public int getValue() {
			return lValue;
		}
		public void setValue(int lValue) {
			this.lValue = lValue;
		}
	}
	
	 public static class HFExtendMeta
	 {//length = 16
	        private int lType;                 //չݵ
	        private int  ulNumOfData;          //չݵĸ
	        private Object objectArrData;
			public int getlType() {
				return lType;
			}
			public void setlType(int lType) {
				this.lType = lType;
			}
			public int getUlNumOfData() {
				return ulNumOfData;
			}
			public void setUlNumOfData(int ulNumOfData) {
				this.ulNumOfData = ulNumOfData;
			}
			public Object getObjectArrData() {
				return objectArrData;
			}
			public void setObjectArrData(Object objectArrData) {
				this.objectArrData = objectArrData;
			}
	 }
	//BaseObject洢ṹ
	public static class HFObjectStorage {
		private int			Id;						/*ؼID*/			
		//private String		Name;				/*ؼ*/
		private Object		Name;					/*ؼ*/
		private int			Length;					/*ؼƳ*/
		//private HFWidgetBound	Bound;				/*ؼλúʹС*/
		private Object		Bound;					/*ؼλúʹС*/
		private short		Type;					/*ؼ*/
		private short		SubType;				/*ؼ*/
		private byte        b7ExtendAttr;           /*Ը*/
		private byte        b2VeiledEffect;
		private Object 		WidgetName;
		private	ArrayList<HFExtendAttrStorage>  ExtendAttrs;    /**/
		public HFObjectStorage() {
			WidgetName = "";
			Length = 0;
			Name = new byte [32];
			Bound = new HFWidgetBound(0, 0, 0, 0);
			ExtendAttrs = new ArrayList<HFExtendAttrStorage>();
		}
		public int getId() {
			return Id;
		}
		public void setId(int id) {
			Id = id;
		}
		public String getName() {
			if(Length > 0 && Name != null && Name instanceof byte []) {
				//long startTimes = System.currentTimeMillis();	
				byte [] buffer = (byte [])Name;
				try {
					WidgetName = new String(buffer, 0, Length, "UTF-8");
				} catch (UnsupportedEncodingException e) {
				}
				Name = null;
				Length = 0;
				buffer = null;
				//long diffTimes = System.currentTimeMillis() - startTimes;	        
				//Log.e("CLDLOGTAG", "1------getName: " + diffTimes);					
			}
			return (String) WidgetName;
		}
		public void setName(String name) {
			WidgetName = name;
		}
		public HFWidgetBound getBound() {
			return (HFWidgetBound) Bound;
		}
		public void setBound(int left, int top, int width, int height) {
			if(Bound != null) {
				((HFWidgetBound)Bound).setLeft(left);
				((HFWidgetBound)Bound).setTop(top);
				((HFWidgetBound)Bound).setWidth(width);
				((HFWidgetBound)Bound).setHeight(height);
			}
		}
		public void setBound(HFWidgetBound bound) {
			if(bound != null && Bound != null) {
				((HFWidgetBound)Bound).setLeft(bound.getLeft());
				((HFWidgetBound)Bound).setTop(bound.getTop());
				((HFWidgetBound)Bound).setWidth(bound.getWidth());
				((HFWidgetBound)Bound).setHeight(bound.getHeight());
			}
		}
		public short getType() {
			return Type;
		}
		public void setType(short type) {
			Type = type;
		}
		public short getSubType() {
			return SubType;
		}
		public void setSubType(short subType) {
			SubType = subType;
		}
		protected int getLength() {
			return Length;
		}
		public byte getNumOfExtendAttr() {
			return b7ExtendAttr;
		}
		public void setNumOfExtendAttr(byte b7ExtendAttr) {
			this.b7ExtendAttr = b7ExtendAttr;
		}
		
		public Object createExtendAttrItem(int index) {
			HFExtendAttrStorage item = null;
			if((item = getExtendAttrItem(index)) == null) {
				item = new HFExtendAttrStorage();
				ExtendAttrs.add(item);
			}
			return item;
		}
		
		public HFExtendAttrStorage getExtendAttrItem(int index) {
			HFExtendAttrStorage item = null;
			if(index >= 0 && index < ExtendAttrs.size()) {
				item = ExtendAttrs.get(index);
			}
			return item;
		}
		
		public ArrayList<HFExtendAttrStorage> getExtendAttrs() {
			return ExtendAttrs;
		}
		public void setExtendAttrs(ArrayList<HFExtendAttrStorage> extendAttrs) {
			ExtendAttrs = extendAttrs;
		}
		
		/*=======================================================
		:ȡ̶״
		:  
		ֵ: 
		======================================================*/
		public int getFixedShapeEnabled(){
			if(ExtendAttrs != null){
				for(int i = 0; i < ExtendAttrs.size(); i++){
					HFExtendAttrStorage item = ExtendAttrs.get(i);
					if(item.getType() == HFExtendAttrType.eExtendAttrType_BASFixedShape && item.getValue() > 0)
						return item.getValue();
				}
			}
			return 0;
		}
		
		/*=======================================================
		:ù̶״
		:  
		ֵ: 
		======================================================*/
		public void setFixedShapeEnabled(boolean enabled){
			if(ExtendAttrs != null){
				for(int i = 0; i < ExtendAttrs.size(); i++){
					HFExtendAttrStorage item = ExtendAttrs.get(i);
					if(item.getType() == HFExtendAttrType.eExtendAttrType_BASFixedShape)
						item.setValue(enabled?1:0);
				}
			}
		}
		

		/*=======================================================
		:ȡԲǰ뾶ֵ
		:  
		ֵ: 
		======================================================*/
		public int getRadius(){
			if(ExtendAttrs != null){
				for(int i = 0; i < ExtendAttrs.size(); i++){
					HFExtendAttrStorage item = ExtendAttrs.get(i);
					if(item.getType() == HFExtendAttrType.eExtendAttrType_BTNRoundRadius && item.getValue() > 0)
						return item.getValue();
				}
			}
			return 0;
		}
		
		/*=======================================================
		:Բǰ뾶
		:  
		ֵ: 
		======================================================*/
		public void setRadius(int radius){
			if(ExtendAttrs != null){
				for(int i = 0; i < ExtendAttrs.size(); i++){
					HFExtendAttrStorage item = ExtendAttrs.get(i);
					if(item.getType() == HFExtendAttrType.eExtendAttrType_BTNRoundRadius)
						item.setValue(radius);
				}
			}
		}
		
		
		
		public byte getB2VeiledEffect() {
			return b2VeiledEffect;
		}
		
		public void setB2VeiledEffect(byte b2VeiledEffect) {
			this.b2VeiledEffect = b2VeiledEffect;
		}
		
		/*=======================================================
		:ȡ߿ɫ
		:  
		ֵ: 
		======================================================*/
		public int getBorderColor(){
			if(ExtendAttrs != null){
				for(int i = 0; i < ExtendAttrs.size(); i++){
					HFExtendAttrStorage item = ExtendAttrs.get(i);
					if(item.getType() == HFExtendAttrType.eExtendAttrType_BTNBorderColor && item.getValue() > 0)
						return item.getValue();
				}
			}
			return -1;
		}
		/*=======================================================
		:ñ߿ɫ
		:  
		ֵ: 
		======================================================*/
		public void setBorderColor(int color){
			if(ExtendAttrs != null){
				for(int i = 0; i < ExtendAttrs.size(); i++){
					HFExtendAttrStorage item = ExtendAttrs.get(i);
					if(item.getType() == HFExtendAttrType.eExtendAttrType_BTNBorderColor)
						item.setValue(color);
				}
			}
		}
	}
	//ͼƬĴ洢ṹ
	public static class HFDrawableStorage {
	    private short               Effect;           //ͼƬЧɫЧ
	    private short               Render;           //ͼƬȾʽ
	    private int                 Color;            //ɫ
	    private int             	Bitmap;     		//ͼƬ
	    private int					ColorFilter;		//͸ɫ
	    private short				Width;				//ͼƬʵʿ
	    private short				Height;			//ͼƬʵʸ߶
	    
		public int getEffect() {
			return Effect;
		}
		public void setEffect(int effect) {
			Effect = (short) effect;
		}
		public short getRender() {
			return Render;
		}
		public void setRender(int render) {
			Render = (short) render;
		}
		public int getColor() {
			return Color;
		}
		public void setColor(int color) {
			Color = color;
		}
		public int getBitmap() {
			return Bitmap;
		}
		public void setBitmap(int id) {
			Bitmap = id;
		}
		public int getColorFilter() {
			return ColorFilter;
		}
		public void setColorFilter(int colorFilter) {
			ColorFilter = colorFilter;
		}
		public int getWidth() {
			return Width;
		}
		public void setWidth(int width) {
			Width = (short) width;
		}
		public int getHeight() {
			return Height;
		}
		public void setHeight(int height) {
			Height = (short) height;
		}
		public void setDrawable(HFDrawableStorage drawable) {
			if(drawable != null) {
				this.setBitmap(drawable.getBitmap()); 
				this.setColor(drawable.getColor());
				this.setColorFilter(drawable.getColorFilter());
				this.setEffect(drawable.getEffect());
				this.setHeight(drawable.getHeight());
				this.setWidth(drawable.getWidth());
				this.setRender(drawable.getRender());
			}
		}	
	}
	//BaseWidgetĴ洢ṹ
	public static class HFBaseStorage extends HFObjectStorage {
		private long 				Parent;				//ؼID
		//private HFDrawableStorage	DefaultDrawable;	//ɫͼƬ
		private Object				DefaultDrawable;	//ɫͼƬ
		private short				order;					/*ؼ*/			
		private short				leftOrder;				/**/		
		private short				rightOrder;				/*ҷ*/		
		private short				upOrder;				/*Ϸ*/		
		private short				downOrder;				/*·*/			
		private short               Alpha;					//͸־(0-100)
		private short				visible;				//Ƿɼ
		private int                 binder;                 //󶨿ؼı־(ͬGroupId)
		
		public HFBaseStorage() {
			DefaultDrawable = new HFDrawableStorage();
		}
		public HFDrawableStorage getDefaultDrawable() {
			return (HFDrawableStorage) DefaultDrawable;
		}
		public void setDefaultDrawable(HFDrawableStorage defaultDrawable) {
			HFDrawableStorage drawable = (HFDrawableStorage) DefaultDrawable;
			if(defaultDrawable != null && drawable != null) {
			}
		}
		public long getParent() {
			return Parent;
		}
		public void setParent(long parent) {
			Parent = parent;
		}
		public int getAlpha() {
			return Alpha;
		}
		public void setAlpha(int alpha) {
			Alpha = (short) alpha;
		}
		public int getOrder() {
			return order;
		}
		public void setOrder(int order) {
			this.order = (short) order;
		}
		public int getLeftOrder() {
			return leftOrder;
		}
		public void setLeftOrder(int leftOrder) {
			this.leftOrder = (short) leftOrder;
		}
		public int getRightOrder() {
			return rightOrder;
		}
		public void setRightOrder(int rightOrder) {
			this.rightOrder = (short) rightOrder;
		}
		public int getUpOrder() {
			return upOrder;
		}
		public void setUpOrder(int upOrder) {
			this.upOrder = (short) upOrder;
		}
		public int getDownOrder() {
			return downOrder;
		}
		public void setDownOrder(int downOrder) {
			this.downOrder = (short) downOrder;
		}
		public int getVisible() {
			return visible;
		}
		public void setVisible(int visible) {
			this.visible = (short) visible;
		}
		public int getBinder() {
			return binder;
		}
		public void setBinder(int binder) {
			this.binder = binder;
		}
	}
	//ıݽṹ
	public static class HFTextItemStorage extends HFBaseStorage {
		//private long				Offset;			/*ıƫ*/		
		//private long				Length;			/*ıĳ*/
		//private String			text;			//ı
		private Object				text;			/*ı*/
		private int					textLength;		/*ıĳ*/
		//private HFWidgetRect		Margin;			/*ı*/	
		//private HFWidgetFont		Font;			/**/
		private Object				Margin;			/*ı*/	
		private Object				Font;			/**/	
		private int					NormalColor;	/*ɫ*/		
		private int					ClickColor;		/*ɫ*/		
		private int					FocusColor;		/*ɫ*/		
		private int					DisableColor;	/*ɫ*/		
		private short				Align;			/*뷽ʽ*/
		
		public HFTextItemStorage() {
			text = new char[12];
			textLength = 0;
			Margin = new HFWidgetRect();
			Font = new HFWidgetFont();
		}
		public HFWidgetRect getMargin() {
			return (HFWidgetRect) Margin;
		}
		public void setMargin(HFWidgetRect margin) {
			HFWidgetRect rect = (HFWidgetRect) Margin;
			if(margin != null && rect != null) {
				rect.setLeft(margin.getLeft());
				rect.setTop(margin.getTop());
				rect.setRight(margin.getRight());
				rect.setBottom(margin.getBottom());
			}
		}
		public HFWidgetFont getFont() {
			return (HFWidgetFont) Font;
		}
		public void setFont(HFWidgetFont font) {
			HFWidgetFont ft = (HFWidgetFont) Font;
			if(font != null && ft != null) {
				ft.setSize(font.getSize());
				ft.setStyle(font.getStyle());
				ft.setTypeface(font.getTypeface());
			}
		}
		public int getNormalColor() {
			return NormalColor;
		}
		public void setNormalColor(int color) {
			NormalColor = color;
		}
		public int getClickColor() {
			return ClickColor;
		}
		public void setClickColor(int color) {
			ClickColor = color;
		}
		public int getFocusColor() {
			return FocusColor;
		}
		public void setFocusColor(int color) {
			FocusColor = color;
		}
		public int getDisableColor() {
			return DisableColor;
		}
		public void setDisableColor(int color) {
			DisableColor = color;
		}
		public int getAlign() {
			return Align;
		}
		public void setAlign(int align) {
			Align = (short) align;
		}
		public String getText() {
			if(textLength > 0 && text != null && text instanceof char []) {
				//long startTimes = System.currentTimeMillis();	
				char [] buffer = (char [])text;
				text = new String(buffer).trim();
				buffer = null;
				textLength = 0;
				//long diffTimes = System.currentTimeMillis() - startTimes;	        
				//Log.e("CLDLOGTAG", "2------getText: " + diffTimes);		
			} 
			
			if(text instanceof String) {
				return (String)text;
			}
			return "";
		}
		protected long getTextLength() {
			return textLength;
		}	
	}
	//Buttonؼ洢ݽṹ
	public static class HFButtonStorage extends HFTextItemStorage {
		private Object	FocusDrawable;		/*״̬ͼƬɫϢ*/	
		private Object	ClickDrawable;		/*״̬ͼƬɫϢ*/	
		private Object	DisableDrawable;	/*״̬ͼƬɫϢ*/
		
		public HFButtonStorage() {
			FocusDrawable = new HFDrawableStorage();
			ClickDrawable = new HFDrawableStorage();
			DisableDrawable = new HFDrawableStorage();
		}		
		public HFDrawableStorage getFocusDrawable() {
			return (HFDrawableStorage) FocusDrawable;
		}
		public void setFocusDrawable(HFDrawableStorage focusDrawable) {
			HFDrawableStorage drawable = (HFDrawableStorage) FocusDrawable;
			if(focusDrawable != null && drawable != null) {
				drawable.setDrawable(focusDrawable);
			}
		}
		public HFDrawableStorage getClickDrawable() {
			return (HFDrawableStorage) ClickDrawable;
		}
		public void setClickDrawable(HFDrawableStorage clickDrawable) {
			HFDrawableStorage drawable = (HFDrawableStorage) ClickDrawable;
			if(clickDrawable != null && drawable != null) {
				drawable.setDrawable(clickDrawable);
			}
		}
		public HFDrawableStorage getDisableDrawable() {
			return (HFDrawableStorage) DisableDrawable;
		}
		public void setDisableDrawable(HFDrawableStorage disableDrawable) {
			HFDrawableStorage drawable = (HFDrawableStorage)DisableDrawable;
			if(disableDrawable != null && drawable != null) {
				drawable.setDrawable(disableDrawable);
			}
		}
	}
	//SwitchStorageؼ洢ݽṹ
	public static class HFSwitchStorage extends HFButtonStorage {
		private Object	switchBound;					/*switchͼƬλ*/			
		private Object	switchOnDefaultDrawable;		/*On״̬ͼƬɫϢ*/	
		private Object	switchOnFocusDrawable;			/*On״̬ͼƬɫϢ*/	
		private Object	switchOnClickDrawable;			/*On״̬ͼƬɫϢ*/	
		private Object	switchOnDisableDrawable;		/*On״̬ͼƬɫϢ*/	
		private Object	switchOffDefaultDrawable;		/*Off״̬ͼƬɫϢ*/	
		private Object	switchOffFocusDrawable;			/*Off״̬ͼƬɫϢ*/	
		private Object	switchOffClickDrawable;			/*Off״̬ͼƬɫϢ*/	
		private Object	switchOffDisableDrawable;		/*Off״̬ͼƬɫϢ*/
		
		public HFSwitchStorage() {
			switchBound = new HFWidgetBound();
			switchOnDefaultDrawable = new HFDrawableStorage();
			switchOnFocusDrawable = new HFDrawableStorage();
			switchOnClickDrawable = new HFDrawableStorage();
			switchOnDisableDrawable = new HFDrawableStorage();
			switchOffDefaultDrawable = new HFDrawableStorage();
			switchOffFocusDrawable = new HFDrawableStorage();
			switchOffClickDrawable = new HFDrawableStorage();
			switchOffDisableDrawable = new HFDrawableStorage();
		}
		public HFWidgetBound getSwitchBound() {
			return (HFWidgetBound) switchBound;
		}
		public HFDrawableStorage getSwitchOnDefaultDrawable() {
			return (HFDrawableStorage) switchOnDefaultDrawable;
		}
		public HFDrawableStorage getSwitchOnFocusDrawable() {
			return (HFDrawableStorage) switchOnFocusDrawable;
		}
		public HFDrawableStorage getSwitchOnClickDrawable() {
			return (HFDrawableStorage) switchOnClickDrawable;
		}
		public HFDrawableStorage getSwitchOnDisableDrawable() {
			return (HFDrawableStorage) switchOnDisableDrawable;
		}
		public HFDrawableStorage getSwitchOffDefaultDrawable() {
			return (HFDrawableStorage) switchOffDefaultDrawable;
		}
		public HFDrawableStorage getSwitchOffFocusDrawable() {
			return (HFDrawableStorage) switchOffFocusDrawable;
		}
		public HFDrawableStorage getSwitchOffClickDrawable() {
			return (HFDrawableStorage) switchOffClickDrawable;
		}
		public HFDrawableStorage getSwitchOffDisableDrawable() {
			return (HFDrawableStorage) switchOffDisableDrawable;
		}
	}	
	//CheckBoxStorage洢ݽṹ
	public static class HFCheckBoxStorage extends HFSwitchStorage{};
	//RadioButtonStorage洢ݽṹ	
	public static class HFRadioButtonStorage extends HFSwitchStorage {
		private int  groupId;    /*Id*/

		public int getGroupId() {
			return groupId;
		}
		public void setGroupId(int groupId) {
			this.groupId = groupId;
		}		
	}	
	//Labelؼ洢ݽṹ
	public static class HFLabelStorage extends HFTextItemStorage {
		private Object				border;			/*߿ĿȺɫ*/	
		private int					ellipsize;		/*ʡԱ־*/		
		private int					multiLines;		/*ʾ*/			
		private int					marquee;		/*ʽ*/
		
		public HFLabelStorage() {
			border = new HFWidgetBorder();
		}
		public HFWidgetBorder getBorder() {
			return (HFWidgetBorder) border;
		}
		public int getEllipsize() {
			return ellipsize;
		}
		public void setEllipsize(int ellipsize) {
			this.ellipsize = ellipsize;
		}
		public int getMultiLines() {
			return multiLines;
		}
		public void setMultiLines(int multiLines) {
			this.multiLines = multiLines;
		}
		public int getMarquee() {
			return marquee;
		}
		public void setMarquee(int marquee) {
			this.marquee = marquee;
		}			
	}
	//EditStorageؼ洢ݽṹ
	public static class HFEditStorage extends HFTextItemStorage {
		
		private Object	border;			/*߿*/				
		private int		inputType;		/*1*/
		
		public HFEditStorage() {
			border = new HFWidgetBorder();
		}
		public HFWidgetBorder getBorder() {
			return (HFWidgetBorder) border;
		}
		public int getInputType() {
			return inputType;
		}
		public void setInputType(int inputType) {
			this.inputType = inputType;
		}			
	}	
	//SearchEditؼ洢ݽṹ
	public static class HFSearchEditStorage extends HFEditStorage{

		private Object button = null;
		
		public HFSearchEditStorage() {
			button = new HFButtonStorage();
		}
		public HFButtonStorage getButton() {
			return (HFButtonStorage) button;
		}
	}
	//ImageStorageؼ洢ݽṹ
	public static class HFImageStorage extends HFBaseStorage {
		//private HFDrawableStorage	Image;				/*ͼƬ*/		
		private Object Image;				/*ͼƬ*/
		private short BitmapAlpha;				/*͸*/
		
		public HFImageStorage() {
			Image = new HFDrawableStorage();
		}
		public HFDrawableStorage getImage() {
			return (HFDrawableStorage) Image;
		}
		public void setImage(HFDrawableStorage image) {
			Image = image;
		}
		public int getBitmapAlpha() {
			return BitmapAlpha;
		}
		public void setBitmapAlpha(int bitmapAlpha) {
			BitmapAlpha = (short) bitmapAlpha;
		}	
	}
	//ImageFrameStorageؼ洢ݽṹ
	public static class HFImageItemStorage {
		private int     lKey;  //Ψһ־
		private Object  tDrawable;  //ҪͼƬ
		public HFImageItemStorage(){
			tDrawable = new HFDrawableStorage();
		}
		public int getlKey() {
			return lKey;
		}
		public void setlKey(int lKey) {
			this.lKey = lKey;
		}
		public HFDrawableStorage getDrawable() {
			return (HFDrawableStorage) tDrawable;
		}
		public void setDrawable(HFDrawableStorage tDrawable) {
			this.tDrawable = tDrawable;
		}
	}	
	//ImageListStorageؼ洢ݽṹ
	public static class HFImageListStorage extends HFBaseStorage {
		private int	lNumOfImages;		/*ͼƬ*/		
		private	ArrayList<HFImageItemStorage>  tImages;    /*ͼƬ*/
		
		public HFImageListStorage()
		{
			settImages(new ArrayList<HFImageItemStorage>());
		}
		
		public Object createImageItem(int index) {
			HFImageItemStorage item = null;
			if((item = getImageItem(index)) == null) {
				item = new HFImageItemStorage();
				tImages.add(item);
			}
			return item;
		}
		
		public HFImageItemStorage getImageItem(int index) {
			HFImageItemStorage item = null;
			if(index >= 0 && index < tImages.size()) {
				item = tImages.get(index);
			}
			return item;
		}

		public int getNumOfImages() {
			return lNumOfImages;
		}

		public void setNumOfImages(int lNumOfImages) {
			this.lNumOfImages = lNumOfImages;
		}

		public ArrayList<HFImageItemStorage> gettImages() {
			return tImages;
		}

		public void settImages(ArrayList<HFImageItemStorage> tImages) {
			this.tImages = tImages;
		}
	}
	//ImageFrameStorageؼ洢ݽṹ
	public static class HFImageFrameStorage {
		
	    private Object  drawable;  //ҪŵͼƬ
	    private int     duration;  //ŸͼƬʱ
	    
	    public HFImageFrameStorage() {
	    	drawable = new HFDrawableStorage();
	    }
		public HFDrawableStorage getDrawable() {
			return (HFDrawableStorage) drawable;
		}
		public int getDuration() {
			return duration;
		}
		public void setDuration(int duration) {
			this.duration = duration;
		}
	}	
	//AnimationStorageؼ洢ݽṹ
	public static class HFAnimationStorage extends HFBaseStorage{
		private int								bitmapAlpha;	/*͸*/	
		private	int								oneshot;		/*Ͷ*/	
		//private	int							numOfFrames;	/*֡*/		
		private	ArrayList<HFImageFrameStorage>  frames;			/*֡*/
		
		public HFAnimationStorage() {
			frames = new ArrayList<HFImageFrameStorage>();
		}
		public int getBitmapAlpha() {
			return bitmapAlpha;
		}
		public void setBitmapAlpha(int bitmapAlpha) {
			this.bitmapAlpha = bitmapAlpha;
		}
		public int getOneshot() {
			return oneshot;
		}
		public void setOneshot(int oneshot) {
			this.oneshot = oneshot;
		}
		public int getNumOfFrames() {
			return frames.size();
		}	
		//public HFImageFrameStorage createFrame(int index) {
		public Object createFrame(int index) {
			HFImageFrameStorage frame = null;
			if((frame = getFrame(index)) == null) {
				frame = new HFImageFrameStorage();
				frames.add(frame);
			}
			return frame;
		}
		public HFImageFrameStorage getFrame(int index) {
			HFImageFrameStorage frame = null;
			if(index >= 0 && index < getNumOfFrames()) {
				frame = frames.get(index);
			}
			return frame;
		}
	}	
	//洢ݽṹ
	public static class HFProgressItemStorage {
		private Object             startDrawable;   /*ͼƬɫ*/		
		private Object             endDrawable;	/*ͼƬɫ*/		
		private Object             centerDrawable;	/*ͼƬɫ*/
		
		public HFProgressItemStorage() {
			startDrawable = new HFDrawableStorage();
			endDrawable = new HFDrawableStorage();
			centerDrawable = new HFDrawableStorage();		
		}
		public HFDrawableStorage getStartDrawable() {
			return (HFDrawableStorage) startDrawable;
		}
		public HFDrawableStorage getEndDrawable() {
			return (HFDrawableStorage) endDrawable;
		}
		public HFDrawableStorage getCenterDrawable() {
			return (HFDrawableStorage) centerDrawable;
		}
	}
	//洢ݽṹ
	public static class HFProgressStorage extends HFBaseStorage {
		private Object pogressBound;	/*Ļλ*/	
		private Object progressItem;	/*ֵ*/			
		private int    progressStyle;  /**/	
		
		public HFProgressStorage() {
			pogressBound = new HFWidgetBound();
			progressItem = new HFProgressItemStorage();
		}
		public HFWidgetBound getPogressBound() {
			return (HFWidgetBound) pogressBound;
		}
		public HFProgressItemStorage getProgressItem() {
			return (HFProgressItemStorage) progressItem;
		}
		public int getProgressStyle() {
			return progressStyle;
		}
		public void setProgressStyle(int progressStyle) {
			this.progressStyle = progressStyle;
		}
	}
	//Layerؼ洢ݽṹ
	public static class HFLayerStorage extends HFBaseStorage {
		
		private int 			Zorder;				/*ͼZ*/	        
		private int 			OffsetOfWidgets;	/*ؼļеƫ*/	
		private int 			NumOfWidgets;		/*ؼĸ*/
		private boolean 		IsOptimized;			/*Żװؿؼ*/
		
		public int getZorder() {
			return Zorder;
		}
		public void setZorder(int zorder) {
			Zorder = zorder;
		}
		public int getOffsetOfWidgets() {
			return OffsetOfWidgets;
		}
		public void setOffsetOfWidgets(int offsetOfWidgets) {
			OffsetOfWidgets = offsetOfWidgets;
		}
		public int getNumOfWidgets() {
			return NumOfWidgets;
		}
		public void setNumOfWidgets(int numOfWidgets) {
			NumOfWidgets = numOfWidgets;
		}
		public boolean isOptimized() {
			return IsOptimized;
		}
		public void setIsOptimized(boolean isOptimized) {
			IsOptimized = isOptimized;
		}
	}
	//ģʽͷļṹ--ModeHeader
		public static class HFModeStorage {
			
		    private String		OrientsMd5;    	//лͷϢУֵ
		    private int			ModeId;			//ģʽId
		    private String		ModeName;		//ģʽ
		    private short		Width;          //Ļ
		    private short		Height;         //Ļ
		    private int			NumOfOrients;   //Ļĸ
		    private byte        b2VeiledEffect; //ɴЧ(0:  1: ɴ)
		    private byte		b4ExtendCount1;	//ɵĸԸ
		    private byte		b4ExtendCount2;	//µĸԸ
		    private Object      ExtendObjectArr;//
		    private	ArrayList<HFExtendAttrStorage>  ExtendObjectArr2;    /*¸*/
			public HFModeStorage() {
				ExtendObjectArr2 = new ArrayList<HFExtendAttrStorage>();
			}
			public String getOrientsMd5() {
				return OrientsMd5;
			}
			public void setOrientsMd5(String orientsMd5) {
				OrientsMd5 = orientsMd5;
			}
			public int getModeId() {
				return ModeId;
			}
			public void setModeId(int modeId) {
				ModeId = modeId;
			}
			public String getModeName() {
				if(ModeName == null)
					return " ";
				return ModeName;
			}
			public void setModeName(String modeName) {
				ModeName = modeName;
			}
			public int getWidth() {
				return Width;
			}
			public void setWidth(int width) {
				Width = (short) width;
			}
			public int getHeight() {
				return Height;
			}
			public void setHeight(int height) {
				Height = (short) height;
			}
			public int getNumOfOrients() {
				return NumOfOrients;
			}
			public void setNumOfOrients(int numOfOrients) {
				NumOfOrients = numOfOrients;
			}
			public byte getExtendCount1() {
				return b4ExtendCount1;
			}
			public void setExtendCount(byte bExtendCount) {
				this.b4ExtendCount1 = bExtendCount;
			}
			public HFExtendMeta[] getExtendObjectArr() {
				return (HFExtendMeta[]) ExtendObjectArr;
			}
			public void setExtendObjectArr(HFExtendMeta[] extendObjectArr) {
				ExtendObjectArr = extendObjectArr;
			}
			public HFWidgetRect[] getMargin(){
				if(ExtendObjectArr != null){
					for(HFExtendMeta meta : getExtendObjectArr()){
						//margin
						if(meta.lType == 2)
							return (HFWidgetRect[]) meta.objectArrData;
					}
					return null;
				}
				else
					return null;
			}
			
			public byte getB2VeiledEffect() {
				return b2VeiledEffect;
			}
			public void setB2VeiledEffect(byte b2VeiledEffect) {
				this.b2VeiledEffect = b2VeiledEffect;
			}
			public byte getExtendCount2() {
				return b4ExtendCount2;
			}
			public void setExtendCount2(byte bExtendCount) {
				this.b4ExtendCount2 = bExtendCount;
			}
			public Object createExtendAttrItem(int index) {
				HFExtendAttrStorage item = null;
				if((item = getExtendAttrItem(index)) == null) {
					item = new HFExtendAttrStorage();
					ExtendObjectArr2.add(item);
				}
				return item;
			}
			
			public HFExtendAttrStorage getExtendAttrItem(int index) {
				HFExtendAttrStorage item = null;
				if(index >= 0 && index < ExtendObjectArr2.size()) {
					item = ExtendObjectArr2.get(index);
				}
				return item;
			}
			
			public ArrayList<HFExtendAttrStorage> getExtendObjectArr2() {
				return ExtendObjectArr2;
			}
			public void setExtendObjectArr2(ArrayList<HFExtendAttrStorage> extendAttrs) {
				ExtendObjectArr2 = extendAttrs;
			}
			
		}
	//ScrollBarؼ洢ݽṹ
	public static class HFScrollBarStorage extends HFBaseStorage{
		
		private Object		pageUpButton = null;		/*Ϸҳť*/				
		private Object		pageDownButton = null;		/*Ϸҳť*/				
		//2012.07.13
		private Object		pageBox = null;			/**/				
		private Object		pageSlider = null;			/**/						
		private int			numPerPage;			/*ÿҳʾ()*/	
		private int			longPressTimes;		/*ʱ(ms)*/	
		private int			responseMode;		/*հ״Ӧʽ*/	
		
		public HFScrollBarStorage() {
			pageUpButton 	= 	new HFButtonStorage();
			pageDownButton	=	new HFButtonStorage();
			pageBox = new HFLabelStorage();
			pageSlider = new HFLabelStorage();
		}
		public HFButtonStorage getPageUpButton() {
			return (HFButtonStorage) pageUpButton;
		}
		public HFButtonStorage getPageDownButton() {
			return (HFButtonStorage) pageDownButton;
		}
		public HFLabelStorage getPageBox() {
			return (HFLabelStorage) pageBox;
		}
		public HFLabelStorage getPageSlider() {
			return (HFLabelStorage) pageSlider;
		}
		public int getNumPerPage() {
			return numPerPage;
		}
		public void setNumPerPage(int numPerPage) {
			this.numPerPage = numPerPage;
		}
		public int getLongPressTimes() {
			return longPressTimes;
		}
		public void setLongPressTimes(int longPressTimes) {
			this.longPressTimes = longPressTimes;
		}
		public int getResponseMode() {
			return responseMode;
		}
		public void setResponseMode(int responseMode) {
			this.responseMode = responseMode;
		}
	}	
	//ListItemؼ洢ݽṹ	
	public static class HFListItemStorage extends HFButtonStorage {

		private int layerId;	/*ͼId*/		
		private int itemType;	/*б*/
		
		public int getLayerId() {
			return layerId;
		}
		public void setLayerId(int layerId) {
			this.layerId = layerId;
		}
		public int getItemType() {
			return itemType;
		}
		public void setItemType(int itemType) {
			this.itemType = itemType;
		}			
	}
	//Listؼ洢ݽṹ		
	public static class HFListStorage extends HFBaseStorage {
		private Object			scrollBar;		/**/					
		private Object 			firstItemPos;	/*һбĿʼλ*/	
		private short 			gapOfItems;		/*бƫ*/			
		private short 			scrollBarPos;	/*λ*/			
		private int 			listStyle;		/*бķ*/				
		//private int 			numOfListItems;	/*ܶӦб*/	
		private ArrayList<HFListItemStorage> listItems;		/*б*/
		
		public HFListStorage() {
			listItems = new ArrayList<HFListItemStorage>();
			scrollBar = new HFScrollBarStorage();
			firstItemPos = new HFPointStorage();
		}
		public short getGapOfItems() {
			return gapOfItems;
		}
		public void setGapOfItems(short gapOfItems) {
			this.gapOfItems = gapOfItems;
		}
		public short getScrollBarPos() {
			return scrollBarPos;
		}
		public void setScrollBarPos(short scrollBarPos) {
			this.scrollBarPos = scrollBarPos;
		}
		public int getListStyle() {
			return listStyle;
		}
		public void setListStyle(int listStyle) {
			this.listStyle = listStyle;
		}
		public int getNumOfListItems() {
			return listItems.size();
		}
		public void addItem(HFListItemStorage item) {
			listItems.add(item);
		}
		//public HFListItemStorage createItem(int index) {
		public Object createItem(int index) {
			HFListItemStorage listItem = null;
			if((listItem = getItem(index)) == null) {
				listItem = new HFListItemStorage();
				listItems.add(listItem);
			}
			return listItem;
		}
		public HFListItemStorage getItem(int index) {
			HFListItemStorage listItem = null;
			if(index >= 0 && index < getNumOfListItems()) {
				listItem = listItems.get(index);
			}
			return listItem;
		}
		public HFScrollBarStorage getScrollBar() {
			return (HFScrollBarStorage) scrollBar;
		}
		public HFPointStorage getFirstItemPos() {
			return (HFPointStorage) firstItemPos;
		}
	}	
	//ExpandableListItemб洢
	public static class HFExpandableListItemStorage extends HFButtonStorage {

	    private int childLayerId;     //ͼId
	    private int grouplayerId;     //ͼId(Group)
	    private int listItemType;     //б
	    private int listItemTypeExt;  //бչͣiphoneб
		public int getChildLayerId() {
			return childLayerId;
		}
		public void setChildLayerId(int childLayerId) {
			this.childLayerId = childLayerId;
		}
		public int getGrouplayerId() {
			return grouplayerId;
		}
		public void setGrouplayerId(int grouplayerId) {
			this.grouplayerId = grouplayerId;
		}
		public int getListItemType() {
			return listItemType;
		}
		public void setListItemType(int listItemType) {
			this.listItemType = listItemType;
		}
		public int getListItemTypeExt() {
			return listItemTypeExt;
		}
		public void setListItemTypeExt(int listItemTypeExt) {
			this.listItemTypeExt = listItemTypeExt;
		}
	}
	//ExpandableListб洢
	public static class HFExpandableListStorage extends HFBaseStorage{

		private Object									scrollBar;		/**/					
		private Object 									firstItemPos;	/*һбĿʼλ*/	
		private short 									gapOfItems;		/*бƫ*/			
		private short 									scrollBarPos;	/*λ*/			
		private int 									listStyle;		/*бķ*/				
		private ArrayList<HFExpandableListItemStorage> 	listItems;		/*б*/
		
		public HFExpandableListStorage() {
			listItems = new ArrayList<HFExpandableListItemStorage>();
			scrollBar = new HFScrollBarStorage();
			firstItemPos = new HFPointStorage();
		}
		public int getGapOfItems() {
			return gapOfItems;
		}
		public void setGapOfItems(int gapOfItems) {
			this.gapOfItems = (short) gapOfItems;
		}
		public short getScrollBarPos() {
			return scrollBarPos;
		}
		public void setScrollBarPos(int scrollBarPos) {
			this.scrollBarPos = (short) scrollBarPos;
		}
		public int getListStyle() {
			return listStyle;
		}
		public void setListStyle(int listStyle) {
			this.listStyle = listStyle;
		}
		public int getNumOfListItems() {
			return listItems.size();
		}
		public void addItem(HFExpandableListItemStorage item) {
			listItems.add(item);
		}
		//public HFExpandableListItemStorage createItem(int index) {
		public Object createItem(int index) {
			HFExpandableListItemStorage listItem = null;
			if((listItem = getItem(index)) == null) {
				listItem = new HFExpandableListItemStorage();
				listItems.add(listItem);
			}
			return listItem;
		}
		public HFExpandableListItemStorage getItem(int index) {
			HFExpandableListItemStorage listItem = null;
			if(index >= 0 && index < getNumOfListItems()) {
				listItem = listItems.get(index);
			}
			return listItem;
		}
		public HFScrollBarStorage getScrollBar() {
			return (HFScrollBarStorage) scrollBar;
		}
		public HFPointStorage getFirstItemPos() {
			return (HFPointStorage) firstItemPos;
		}
	}	
	//TabBar ItemĶ
	public static class HFTabItemStorage extends HFBaseStorage{
		
		private int tabWidgetId;	//ָʾ(ǩ)--ͼId		
		private int tabcontentId;	//ʾ--ͼId
		public int getTabWidgetId() {
			return tabWidgetId;
		}
		public void setTabWidgetId(int tabWidgetId) {
			this.tabWidgetId = tabWidgetId;
		}
		public int getTabcontentId() {
			return tabcontentId;
		}
		public void setTabcontentId(int tabcontentId) {
			this.tabcontentId = tabcontentId;
		}
	}
	//TabBarݽṹ
	public static class HFTabBarStorage extends HFBaseStorage {
		
		private int tabStyle;								//tabҳķ (֧ڵײַ)
		private ArrayList<HFTabItemStorage> mTabItems = null; //洢Tabҳ
		
		public HFTabBarStorage() {
			mTabItems = new ArrayList<HFTabItemStorage>();
		}
		public int getNumOfTabs() {
			return mTabItems.size();
		}
		public void addTab(HFTabItemStorage item) {
			mTabItems.add(item);
		}
		//public HFTabItemStorage createItem(int index) {
		public Object createItem(int index) {
			HFTabItemStorage tabItem = null;
			if((tabItem = getTab(index)) == null) {
				tabItem = new HFTabItemStorage();
				mTabItems.add(tabItem);
			}
			return tabItem;
		}
		public HFTabItemStorage getTab(int index) {
			HFTabItemStorage tabItem = null;
			if(index >= 0 && index < getNumOfTabs()) {
				tabItem = mTabItems.get(index);
			}
			return tabItem;
		}
		public int getTabStyle() {
			return tabStyle;
		}
		public void setTabStyle(int tabStyle) {
			this.tabStyle = tabStyle;
		}		
	}
	//MapWidgetؼ洢ݽṹ	
	public static class HFMapStorage extends HFBaseStorage {};
	//MessageBoxݽṹ
	public static class HFMessageBoxStorage extends HFBaseStorage{
		
	    private HFLabelStorage  	mTitle;         //ģʽ
	    private HFImageStorage  	mIcon;          //ʾͼ
	    private HFLabelStorage  	mMessage;       //ʾϢ
	    private HFButtonStorage 	mConfirm;       //ȷϰť
	    private HFButtonStorage 	mCancel;        //ȡť
	    private HFButtonStorage 	mReturn;        //ذť
	    private HFButtonStorage 	mOther;         //ť
	    private int        			mDlgType;      //Ի
	    private int        			mDuration;     //Իʱ
	    
	    public HFMessageBoxStorage() {
	    	mTitle = new HFLabelStorage();
	    	mIcon = new HFImageStorage();
	    	mMessage = new HFLabelStorage();
	    	mConfirm = new HFButtonStorage();
	    	mCancel = new HFButtonStorage();
	    	mReturn = new HFButtonStorage();
	    	mOther = new HFButtonStorage();
	    }
		public HFLabelStorage getTitle() {
			return mTitle;
		}
		public HFImageStorage getIcon() {
			return mIcon;
		}
		public HFLabelStorage getMessage() {
			return mMessage;
		}
		public HFButtonStorage getConfirm() {
			return mConfirm;
		}
		public int getDlgType() {
			return mDlgType;
		}
		public void setDlgType(int dlgType) {
			this.mDlgType = dlgType;
		}
		public int getDuration() {
			return mDuration;
		}
		public void setDuration(int duration) {
			this.mDuration = duration;
		}
		public HFButtonStorage getCancel() {
			return mCancel;
		}
		public HFButtonStorage getmReturn() {
			return mReturn;
		}
		public HFButtonStorage getOther() {
			return mOther;
		}
	}	
	//VarLabelݽṹ
	public static class HFVarLabelStorage extends HFLabelStorage{
		private Object             startDrawable;   /*ͼƬɫ*/		
		private Object             endDrawable;		/*ͼƬɫ*/		
		private Object             centerDrawable;	/*ͼƬɫ*/
		private Object             CurrentDrawable;	/*ͼƬɫ*/
		public HFVarLabelStorage() {
			startDrawable = new HFDrawableStorage();
			endDrawable = new HFDrawableStorage();
			centerDrawable = new HFDrawableStorage();
			CurrentDrawable = new HFDrawableStorage();
		}
		public HFDrawableStorage getStartDrawable() {
			return (HFDrawableStorage) startDrawable;
		}
		public HFDrawableStorage getEndDrawable() {
			return (HFDrawableStorage) endDrawable;
		}
		public HFDrawableStorage getCenterDrawable() {
			return (HFDrawableStorage) centerDrawable;
		}
		public HFDrawableStorage getCurrentDrawable() {
			return (HFDrawableStorage) CurrentDrawable;
		}
	}
	
	//HFSliderݽṹ
	public static class HFSliderStorage extends HFBaseStorage{
		
		private Object 		tButton;			/*ť*/		
		private int				ulMinRange;			/*СΧ*/	
		private int				ulMaxRange;			/*Χ*/	
		private		short				iStartOffset;		/*ʼƫ*/	
		private		short				iEndOffset;			/*ƫ*/	
		private int				ulPosition;			/*ǰλ*/	
		private short				uiSliderStyle;		/**/		
		private byte				ucReserveredf1;		/*1*/		
		private byte				ucReserveredf2;		/*2*/		
		private int				ulLongPressTimes;	/*ʱ(ms)*/ 
		private Object	tStart;				/*ʼͼƬ*/ 
		private Object	tCenter;			/*м䲿ͼƬ*/ 
		private Object	tEnd;				/*ͼƬ*/
		public HFSliderStorage(){
			setButton(new HFButtonStorage());
			setStart(new HFDrawableStorage());
			setCenter(new HFDrawableStorage());
			setEnd(new HFDrawableStorage());
		}
		public HFButtonStorage getButton() {
			return (HFButtonStorage) tButton;
		}
		public void setButton(HFButtonStorage tButton) {
			this.tButton = tButton;
		}
		public int getMinRange() {
			return ulMinRange;
		}
		public void setMinRange(int ulMinRange) {
			this.ulMinRange = ulMinRange;
		}
		public int getMaxRange() {
			return ulMaxRange;
		}
		public void setMaxRange(int ulMaxRange) {
			this.ulMaxRange = ulMaxRange;
		}
		public short getStartOffset() {
			return iStartOffset;
		}
		public void setStartOffset(short iStartOffset) {
			this.iStartOffset = iStartOffset;
		}
		public short getEndOffset() {
			return iEndOffset;
		}
		public void setEndOffset(short iEndOffset) {
			this.iEndOffset = iEndOffset;
		}
		public int getPosition() {
			return ulPosition;
		}
		public void setPosition(int ulPosition) {
			this.ulPosition = ulPosition;
		}
		public short getSliderStyle() {
			return uiSliderStyle;
		}
		public void setSliderStyle(short uiSliderStyle) {
			this.uiSliderStyle = uiSliderStyle;
		}
		public byte getReserveredf1() {
			return ucReserveredf1;
		}
		public void setReserveredf1(byte ucReserveredf1) {
			this.ucReserveredf1 = ucReserveredf1;
		}
		public byte getReserveredf2() {
			return ucReserveredf2;
		}
		public void setReserveredf2(byte ucReserveredf2) {
			this.ucReserveredf2 = ucReserveredf2;
		}
		public int getLongPressTimes() {
			return ulLongPressTimes;
		}
		public void setLongPressTimes(int ulLongPressTimes) {
			this.ulLongPressTimes = ulLongPressTimes;
		}
		public HFDrawableStorage getStart() {
			return (HFDrawableStorage) tStart;
		}
		public void setStart(HFDrawableStorage tStart) {
			this.tStart = tStart;
		}
		public HFDrawableStorage getCenter() {
			return (HFDrawableStorage) tCenter;
		}
		public void setCenter(HFDrawableStorage tCenter) {
			this.tCenter = tCenter;
		}
		public HFDrawableStorage getEnd() {
			return (HFDrawableStorage) tEnd;
		}
		public void setEnd(HFDrawableStorage tEnd) {
			this.tEnd = tEnd;
		}
	}
	
	//PageControl
	public static class HFPageControlStorage extends HFBaseStorage{
	    private int uiNumOfPages; // ĸ
	    private int[] tPageLayerId; // layerIdͼId
		public int getNumOfPages() {
			return uiNumOfPages;
		}
		public void setNumOfPages(int ulNumOfPages) {
			this.uiNumOfPages = ulNumOfPages;
		}
		public int[] getPageLayerIds() {
			return tPageLayerId;
		}
		public void settPageLayerId(int[] tPageLayerId) {
			this.tPageLayerId = tPageLayerId;
		}
	}
	
	public static class HFLongResult {
		private int mData;
		private int mErrorCode;
		
		public HFLongResult(){
			mData = 0;
		}
		public HFLongResult(int data){
			mData = data;
		}		
		public int getData() {
			return mData;
		}
		public void setData(int data) {
			mData = data;
		}
		public int getErrorCode() {
			return mErrorCode;
		}	
	};
		
}
